int onblock(int obl, int obr, int oby, int type)
{
	int result, arrayok, obi, sdif, hdif;

	result = 0;
	ob_onobj = 0;

	if (type < 3) {
		for (obi=0;obi<n_plat;obi++) {
			if (platforms[obi].active == true) {
				if (obl+screen_px+190 >= platforms[obi].x &&
					obl+screen_px <= platforms[obi].x+platforms[obi].width &&
					oby+screen_py >= platforms[obi].y &&
					oby+screen_py <= platforms[obi].y+60) {
					ob_onobj = platforms[obi].obj+1;
					ob_ontype = platforms[obi].obj_type;
					return(1);
				}
			}
		}
	}

	if (type == 0) {
		for (obi=0;obi<n_gears;obi++) {
			if (gear_t[obi] == 0) sdif = 950; else sdif = 460;
			if (obl+130+screen_px > gear_x[obi]-sdif/1.1f && obl+50+screen_px < gear_x[obi]+sdif/1.1f) {
				hdif = (int)(cos(asin((float)(gear_x[obi] - (obl+90) - screen_px)/(float)sdif))*sdif);
				if (oby+screen_py > gear_y[obi]-hdif-30 && oby+screen_py < gear_y[obi]-hdif+100) {
					ob_onobj = obi+1;
					ob_ontype = 2;
					return(1);
				}
			}
		}
	}

	if (door_action < 3) {
		obl = (obl + screen_px)/240;
		obr = (obr + screen_px)/240;
		oby = (oby + screen_py)/240;
		arrayok = 1;
		if (obl < 0 || obr < 0 || oby < 0) arrayok = 0;
		if (obl > nbx || obr > nbx || oby > nby) arrayok = 0;
		if (arrayok == 1) {
			if (t[level[obl][oby]].top == 1) result = 1;
			if (t[level[obr][oby]].top == 1) result = 1;
		}

		if (type == 2) {
			if (obl < 1 || obr > nbx) result = 0;
		}
		
	}

	return result;
}

int inblock(int obx, int obt, int obb, int ttop)
{
	int result, arrayok;
		
	result = 0;

	if (door_action < 3) {
		obx = (obx + screen_px)/240;
		obt = (obt + screen_py)/240;
		obb = (obb + screen_py)/240;
		
		arrayok = 1;
		if (obx < 0 || obt < 0 || obb < 0) arrayok = 0;
		if (obx > nbx || obt > nby || obb > nby) arrayok = 0;
		
		if (arrayok == 1) {
			if (t[level[obx][obt]].side == 1) result = 1;
			if (t[level[obx][(obt+obb)/2]].side == 1) result = 1;
			if (t[level[obx][obb]].side == 1) result = 1;

			if (ttop == 1) {
				if (t[level[obx][obt]].top == 1) result = 1;
				if (t[level[obx][(obt+obb)/2]].top == 1) result = 1;
				if (t[level[obx][obb]].top == 1) result = 1;	
			}
		}
		
	}

	return result;
}

void scroll(int sdir)
{
	screen_px += sdir;
	for (i=0;i<n_stairs;i++) stairs_x[i] -= sdir;
	for (i=0;i<enemy_number;i++) e[i].x -= sdir;
	for (i=0;i<item_number;i++) it[i].x -= sdir;
	for (i=0;i<debris_number;i++) db[i].x -= sdir;
	for (i=0;i<n_sub;i++) sub_x[i] -= sdir;

	fogx1 -= sdir;
	fogx2 -= (sdir*3)/5;
		
	hero_x -= sdir;
}

void yscroll(int sdir)
{
	screen_py += sdir;
	for (i=0;i<n_stairs;i++) { 
		stairs_y[i] -= sdir;
		stairs_top[i] -= sdir;
	}
	for (i=0;i<enemy_number;i++) e[i].y -= sdir;
	for (i=0;i<item_number;i++) it[i].y -= sdir;
	for (i=0;i<debris_number;i++) db[i].y -= sdir;
	for (i=0;i<n_sub;i++) sub_y[i] -= sdir;
		
	hero_y -= sdir;
}

void hurthero(int damage)
{
	hero_action = 7;
	hero_frame = 21;
	hero_difframe = -1;
	hero_phase = 0;	
	if (damage > hero_hp) damage = hero_hp;
	hero_losehp = damage;
	hero_lcycles = 5;
	hero_inv = 1;
	hero_icycles = 6;
	hero_iphase = 0;
	inv_dur = 140;
	hero_onobj = 0;
	hero_lhpdif = -1;
	hero_wcycles = 0;
	hero_throw = 0;
	hero_hittype = 1; //!!!!!!
	hero_hp -= damage;
	if (hero_hp > 0) {
		if (myRand(0,99) < 50)
			FSOUND_PlaySound (FSOUND_FREE, FX_ghit1);
		else
			FSOUND_PlaySound (FSOUND_FREE, FX_ghit2);
	}
	else {
		FSOUND_PlaySound (FSOUND_FREE, FX_dead);
		hero_frame = 45;
		hero_inv = 0;
	}
}

void chkaction(int index)
{
	switch (index) {

	case 0: // stand
		if (command == 0) {
			hero_action = 0;
			hero_frame = 0;
			hero_cycles = 12;
			hero_difframe = 1;
		}
	break;

	case 1: // walk
		if (command == 2 || command == 1) {
			if (hero_onobj > 0 && hero_ontype == 0) {
				if (hero_dir == command-1) {
					if (hero_dir == 0) hero_x -= 70; else hero_x += 70;
				}
			}
			hero_action = 1;
			hero_dir = 2-command;
			hero_frame = 9;
			hero_phase = 0;
			hero_difframe = 0;
			exa = 0;
		}
	break;

	case 2: // crouch
		if (command == 3 && ddelay == 0) {
			hero_action = 2;
			hero_cycles = 4;
			hero_frame = 43;
		}
	break;

	case 3: // jump
		if (Abutton == 1) {
			if (onblock(hero_x+150, hero_x+320, hero_y-240,0) == 0) {
				if (hero_action == 1 && (hero_onobj == 0 || hero_ontype != 0 || kd_left == 1 || kd_right == 1)) {
					hero_action = 4;
					hero_frame = 17;					
					if (hero_onobj > 0 && hero_ontype == 0) {
						if (kd_left) hero_dir = 1;
						if (kd_right) hero_dir = 0;
					}
					hero_jdir = hero_dir;
				}
				else {
					hero_action = 3;
					hero_frame = 16;
					hero_jdir = 2;
				}
				hero_phase = 0;
				hero_cycles = 12;
				hero_jsped = -380;

				exa = 0;
				//if (hero_ontype == 1 || hero_ontype == 2)  ... is this okay?
				hero_onobj = 0;
			}
		}
	break;

	case 4: // ready
		if (command == 4) {
			hero_action = 5;
			hero_frame = 34;
		}
	break;

	case 5: // whip
		if (Bbutton == 1) {
			if (hero_action < 5) {
				if (kd_up == 1 && hero_action != 2) {
					chkaction(6);
				}
				else {
					if (hero_onobj > 0 && hero_ontype == 0) {
						hero_oldcframe = hero_frame;
						if (hero_frame == 48) hero_frame = 59;
						if (hero_frame == 51) hero_frame = 77;
						if (hero_frame == 54) hero_frame = 86;
						if (hero_frame == 57) hero_frame = 68;
						hero_climb = 0;
					}
					else hero_frame = 22;
					if (hero_action == 2) hero_frame = 35;
					if (hero_action == 1) hero_action = 0;
					if (hero_action == 3 || hero_action == 4) hero_frame = 30;
					hero_wcycles = 5;
					hero_wphase = 0;
					exa = 0;
					if (hero_whip == 0) FSOUND_PlaySound (FSOUND_FREE,FX_leather);
					if (hero_whip == 1) FSOUND_PlaySound (FSOUND_FREE,FX_chain);
					if (hero_whip == 2) FSOUND_PlaySound (FSOUND_FREE,FX_vk);
				}
			}
		}
	break;

	case 6: // throw
		if (Bbutton == 1 && hero_weapon > 0 && hearts[1]*10+hearts[0]>0 && (hero_weapon != 6) && n_sub < hero_double + 1) {
			i = 1;
			if (hero_weapon == 2) {
				if (n_sub > 0) i = 0;
				if (hero_double == 1 && hearts[1]*10+hearts[0] < 2) i = 0;
				if (hero_double == 1 && i == 1) {
					hearts[0]--;
					if (hearts[0] < 0) { hearts[0] = 9; hearts[1]--; }
				}
				if (hero_double == 2 && hearts[1]*10+hearts[0] < 3) i = 0;
				if (hero_double == 2 && i == 1) {
					hearts[0]--;
					if (hearts[0] < 0) { hearts[0] = 9; hearts[1]--; }
					hearts[0]--;
					if (hearts[0] < 0) { hearts[0] = 9; hearts[1]--; }
				}	
			}
			if (i == 1) {
				if (hero_action == 1 || hero_action == 5) {
					hero_action = 0;
					hero_cycles = 12;
				}
				hero_wcycles = 4;
				hero_wphase = 0;
				hero_throw = 1;
				if (hero_onobj > 0 && hero_ontype == 0) {
					hero_oldcframe =  hero_frame;
					if (hero_frame == 48) hero_frame = 59;
					if (hero_frame == 51) hero_frame = 77;
					if (hero_frame == 54) hero_frame = 86;
					if (hero_frame == 57) hero_frame = 68;
					hero_climb = 0;
				}
				else {
					hero_frame = 22;
					if (hero_action == 2) hero_frame = 35;
				}
				hearts[0]--;
				if (hearts[0] < 0) { hearts[0] = 9; hearts[1]--; }
				exa = 0;
			}
		}
		if (Bbutton == 1 && hero_weapon == 6 && hearts[1]*10+hearts[0] > 4 && clk_timer == 0) {
			clk_timer = 300;
			freeze = 2;
			FMUSIC_SetPaused (bgmusic, true);
			music_play = 0;
			for (i=0;i<6;i++) {
				clk_phase[i] = 0;
				clk_cycles[i] = 45 + 47*i;
				clk_deg[i] = -30 - i*60;
			}
			hearts[0] -= 5;
			if (hearts[0] < 0) {
				hearts[0] += 10;
				hearts[1]--;
			}
		}
	break;

	case 7: // fall
		if (door_action < 3) {
			if ((onblock(hero_x+130, hero_x+320, hero_y+480,0) <= 0) &&
				(hero_action < 3 || hero_action > 4) && (hero_onobj == 0 || (hero_ontype != 0 && hero_ontype != 2))
				&& (hero_action != 7) && hero_action < 50) {

				if (hero_onobj == 0) {
					if (hero_action == 1)
						hero_x += 35*(1-2*hero_dir);
				}
				else {
					hero_x += 40*(1-2*hero_dir);
					if (hero_ontype == 1) hero_y += 150;
				}
				hero_onobj = 0;
				hero_action = 3;
				hero_phase = 4;
				hero_cycles = 6;
				hero_jsped = 0;
				hero_cjdir = 1;
				hero_jdir = 2;
				exa = 0;
			}
		}
	break;

	}
}

bool Handle_Actions(void)
{
	int i;
	
	if (freeze < 255) time_cycles--;
	
	if (ddelay > 0) ddelay--;
	
	if (time_cycles == 0) {
		time_cycles = 60;
		time[0]--;
		if (time[0] < 0) {
			time[0] = 9;
			time[1]--;
			if (time[1] < 0) {
				time[1] = 9;
				time[2]--;
			}
		}		
		if (time[0]+time[1]+time[2] == 0) {
			hero_frame = 40;
			hero_inv = 0;
		}
		// low time warning!!!
	}

	if (hero_frame == 45) {		
		if (hero_phase > 0) {
			hero_x -= (1-(2*hero_dir)) * 1400 / hero_difframe;
			hero_y += hero_jsped*10 / hero_difframe;
			hero_jsped += 1000 / hero_difframe;

			hero_difframe += 3;

			if (hero_phase == 1) {
				if (hero_jsped > -100) hero_hdif++;
				if (hero_hdif == 100) {
					hero_phase ++;
					hero_hdif = 0;
				}
			}
			if (hero_phase == 2) {
				if (hero_hdif < 100) hero_hdif += 2;
			}
			
			if (hero_jsped > 249) hero_phase = 0;
		}
		else {
		// stop music, play death & wait till song done

		FMUSIC_StopSong(bgmusic);
		
		FMUSIC_PlaySong(death);
		while (FMUSIC_IsPlaying(death)) ;


		players[0]--;
		if (players[0] < 0) { players[0] = 9; players[1]--; }
		if (players[0]+players[1]*10 > -1) {
		
			sprintf(levelname, oldlevel);
			enterat = 0;
			
			hearts[0] = 5; hearts[1] = 0;
			time[0] = 0; time[1] = 0; time[2] = 6;	// !!!!!!!!!!!!!!
			hero_hp = 16;
			boss_hp = 16;
			time_cycles = 60;
	
			clk_timer = 0;
			
			hero_whip = 0;
			hero_weapon = 0;
			hero_double = 0;
			hero_inv = 0;

			FMUSIC_PlaySong(bgmusic);

			return(true);
		}
		
		FMUSIC_PlaySong(gameover);
		
		game_over(); // if gameover == 1, else back to main!
		return(true);
		
		}

		return(false);
	}

	command = 0;
	if (Abutton > 0 && kd_a == 1) Abutton = 2; else Abutton = 0;
	if (Bbutton > 0 && kd_b == 1) Bbutton = 2; else Bbutton = 0;
	if (kd_down == 1) command = 3;
	if (kd_up == 1) command = 4;
	if (kd_left == 1) command = 1;
	if (kd_right == 1) command = 2;
	if (kd_a && Abutton == 0) Abutton = 1;
	if (kd_b && Bbutton == 0) Bbutton = 1;

	if (freeze == 255) {command = 4; Abutton = 0; Bbutton = 0;}

	if (door_action > 0) {
		command = 0;
		Abutton = 0;
		Bbutton = 0;
		if (door_action == 3) {
			if (hero_dir == 0) {
				command = 2;
			}
			else {
				command = 1;
			}
		}
		if (door_action < 3) command = 4;
		if (door_action > 5) command = 2-hero_dir;
	}
				
	if ((hero_action == 0 || hero_action == 1) && door_action == 0) {
		if (hero_onobj > 0 && hero_ontype == 0) {
			if (kd_down && Abutton == 1) {
				command = 0;
				Abutton = 0;
				hero_onobj = 0;
				hero_action = 3;
				hero_phase = 4;
				hero_cycles = 6;
				hero_jsped = 0;
				hero_frame = 20;
				hero_cjdir = 1;
				hero_jdir = 2;
	
			}
			if (command == 4) command = 2 - stairs_dir[hero_onobj-1];
			if (command == 3) command = 2 - (1-stairs_dir[hero_onobj-1]);
		}

		if (command == 3) {
			for (i=0;i<n_stairs;i++) {
				//if ((hero_x < stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-stairs_top[i]-70)
				//	+21-60 + 110*stairs_dir[i]) && (hero_x > stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-
				//	stairs_top[i]-70)-14-60 + 110*stairs_dir[i]) && (hero_y == stairs_top[i])) {
				if ((hero_x < stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-stairs_top[i]-70)
					+21-40 + 110*stairs_dir[i]) && (hero_x > stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-
					stairs_top[i]-70)-14-60 + 110*stairs_dir[i]) && (hero_y == stairs_top[i])) {
						
					hero_onobj = i+1;
					hero_ontype = 0;
					hero_action = 1;
					if (myRand(0,99) > 49) hero_frame = 54;
						else hero_frame = 57;
					hero_phase = 0;
					hero_climb = -2;
					command = 0;
					hero_x = stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-stairs_top[i]-70)+3 -60 + 110*stairs_dir[i];
					hero_y = stairs_top[i] + 80;
					hero_dir = 1-stairs_dir[i];
					hero_oldcframe = hero_frame;
				}
			}
		}

		if (command == 4 && hero_onobj == 0) {
			for (i=0;i<n_stairs;i++) {
				if ((hero_x < stairs_x[i]+34-hero_dir*30) && (hero_x > stairs_x[i]-6-hero_dir*30)
					&& (hero_y == stairs_y[i])) {
					hero_onobj = i+1;
					hero_ontype = 0;
					hero_action = 1;
					if (myRand(0,99) > 49) hero_frame = 48;
						else hero_frame = 51;
					hero_phase = 0;
					hero_climb = -2;
					command = 0;
					hero_x = stairs_x[i]+14-stairs_dir[i]*30;
					hero_dir = stairs_dir[i];
					hero_oldcframe = hero_frame;
				}
			}
		}

	
		for (i=0;i<n_stairs;i++) {
				
			if (command == 4) {
				if (hero_y - 10 < stairs_y[i] && hero_y+10 > stairs_y[i]) {
					if (hero_x > stairs_x[i]-6-hero_dir*30-180 && hero_x < stairs_x[i]+14-hero_dir*30
						&& hero_y == stairs_y[i]) command = 2;
					if (hero_x < stairs_x[i]+34-hero_dir*30+180 && hero_x > stairs_x[i]+14-hero_dir*30
						&& hero_y == stairs_y[i]) command = 1;					
				}
			}
			// !!!!!!! changed 150 to 180
			if (command == 3) {
				if (hero_y-10 < stairs_top[i] && hero_y+10 > stairs_top[i]) {
					if ((hero_x < stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-stairs_top[i]-70)+21-60 + 110*stairs_dir[i]+180)
						&& (hero_x > stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-stairs_top[i]-70)+3-60 + 110*stairs_dir[i])
						&& hero_y == stairs_top[i]) command = 1;
					if ((hero_x > stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-stairs_top[i]-70)-14-60 + 110*stairs_dir[i]-180)
						&& (hero_x < stairs_x[i]+(1-2*stairs_dir[i])*(stairs_y[i]-stairs_top[i]-70)+3-60 + 110*stairs_dir[i])
						&& hero_y == stairs_top[i]) command = 2;
				}
			}	
		}
	
	}

	if (flag[1] == 1) {
		sway_cycles--;
		if (sway_phase == 0) y_offset -= 2;
		if (sway_phase == 2) y_offset += 2;
		if (sway_cycles == 0) {
			if (sway_phase == 1 || sway_phase == 3) sway_cycles = 110;
			if (sway_phase == 0) sway_cycles = 70;
			if (sway_phase == 2) sway_cycles = 30;
			
			sway_phase++;
			if (sway_phase == 4) sway_phase = 0;
		}
	}
		
	if (hero_action < 50) chkaction(7);
	if (hero_inv == 0) {
		for (i=0;i<n_roto;i++) {
			if (roto_spikes[i] == 2) {
				if (hero_y+screen_py == roto_y[i]-480 && (hero_x+screen_px)+250 > roto_x[i] && (hero_x+screen_px)+200 < roto_x[i]+480) {
					hurthero(2);
					hero_jdir = hero_dir;
				}				
			}
			if (roto_spikes[i] == 1 && roto_cycles[i] == 0) {
				if (hero_y+screen_py > roto_y[i]-480 && hero_y+screen_py < roto_y[i]+240 && (hero_x+screen_px)+250 > roto_x[i] && (hero_x+screen_px)+200 < roto_x[i]+480) {
					hurthero(2);
					hero_jdir = hero_dir;
				}				
			}
		}
	}	

	if (hero_action == 0 && hero_wcycles == 0 && (hero_onobj == 0 || hero_ontype != 0)) {
		if (exa < 500) exa++;
		if (command == 0) {
			hero_cycles--;
			if (hero_cycles == 0) {
				hero_frame++;
				if (hero_frame == 7) hero_frame = 0;
				hero_cycles = 5 + exa/100;
			}
		}
		for (i=1;i<6;i++) chkaction(i);
	}

	if (hero_action == 1) {
		if (hero_onobj == 0 || hero_ontype != 0) 
			chkaction(0);
		if (hero_onobj > 0 && hero_ontype == 0 && hero_climb == 0) {
			if (command == 2-hero_dir) hero_climb = 20;
			if (command == 1+hero_dir) {
				hero_climb = -5;
				hero_dir = 1-hero_dir;
				if (hero_dir == stairs_dir[hero_onobj-1]) {
					if (myRand(0,99) > 49) hero_frame = 48;
						else hero_frame = 51;
				}
				else {
					if (myRand(0,99) > 49) hero_frame = 54;
						else hero_frame = 57;
				}
				hero_x += 60*(1-2*hero_dir);
			}
		}
		if (hero_climb < 0 && hero_climb != -100) hero_climb++;
		if (hero_climb == -100 && kd_up == 0) {
			hero_climb = 0;
			hero_frame = hero_oldcframe;
		}
		if (hero_onobj > 0 && hero_ontype == 0 && hero_climb > 0) {
			hero_x += 8*(1-2*hero_dir);
			if (hero_dir == stairs_dir[hero_onobj-1])
				hero_y -= 8;
			else hero_y += 8;

			hero_climb--;
			if (hero_climb == 15 || hero_climb == 8 || hero_climb == 1) {
				hero_frame++;
				if (hero_frame == 52) hero_frame = 46;
				if (hero_frame == 58) hero_frame = 52;
			}
			if ((hero_climb == 0 || hero_climb == 10) 
				&& command != 2-hero_dir) {
				// up
				if (hero_dir == stairs_dir[hero_onobj-1]) {
					if (hero_frame < 49)
						hero_frame = 48;
					else hero_frame = 51;
				}
				else {
					if (hero_frame < 55)
						hero_frame = 54;
					else hero_frame = 57;
				}
				
				hero_climb = -1;				
			}
			if (hero_frame == 48 || hero_frame == 51 || hero_frame == 54 || hero_frame == 57)
				hero_oldcframe = hero_frame;

			if (hero_climb > 15) {
				if (kd_up && Bbutton) {					
					hero_x -= (20-hero_climb)*8*(1-2*hero_dir);
					if (hero_dir == stairs_dir[hero_onobj-1])
						hero_y += (20-hero_climb)*8;
					else hero_y -= (20-hero_climb)*8;
					hero_climb = -1;
				}
			}

			if (hero_onobj > 0 && hero_ontype == 0) {
				
				if (door_action == 0) {
					if (hero_y <= stairs_top[hero_onobj-1]) {
						hero_y = stairs_top[hero_onobj-1];
						hero_x = stairs_x[hero_onobj-1]+(1-2*stairs_dir[hero_onobj-1])
							*(stairs_y[hero_onobj-1]-stairs_top[hero_onobj-1]
							+(1-2*stairs_dir[hero_onobj-1])*30);
						hero_onobj = 0;
						hero_frame = 0;
						hero_action = 0;
					}
							 
					if (hero_onobj > 0 && hero_ontype == 0) {
						if (hero_y >= stairs_y[hero_onobj-1]) {
							hero_y = stairs_y[hero_onobj-1];
							hero_x = stairs_x[hero_onobj-1]-60*(1-2*stairs_dir[hero_onobj-1]);
							hero_onobj = 0;
							hero_frame = 0;
							hero_action = 0;
							ddelay = 8;
						}						
					}
				}
			
			}
		}
		if (command == 2 || command == 1) {			
			if (hero_onobj == 0 || hero_ontype != 0) {
				hero_dir = 2-command;
				hero_x += 13*(1-2*hero_dir);
			}

			if (hero_onobj == 0 || hero_ontype != 0) {
				hero_phase++;
				if (hero_phase == 6) {
					hero_frame++;
					hero_phase = hero_difframe;
					hero_difframe = 1-hero_difframe;
					if (hero_frame == 16) hero_frame = 8;
				}
			} else {

			}
					
		}
		if (hero_onobj == 0 || hero_ontype != 0) {
			if (hero_dir == 0) {
				if (inblock(hero_x+320, hero_y+40, hero_y+440,1) > 0) {
					hero_x = ((hero_x+screen_px)/240)*240+150-screen_px;
				}
			}
			if (hero_dir == 1) {
				if (inblock(hero_x+140, hero_y+40, hero_y+440,1) > 0) {
					hero_x = ((hero_x+screen_px)/240)*240+110-screen_px;
				}
			}

			chkaction(2);
			chkaction(4);			
		}
		chkaction(3);
		if (hero_onobj == 0 || hero_ontype != 0 || hero_climb < 1) {
			
			chkaction(5);
		}
	}

	if ((hero_action == 2 || hero_action == 6) && hero_wcycles == 0) {
		if (hero_cycles > 0) {
			hero_cycles--;
			if (hero_action == 2) {
				if (hero_cycles == 0 && hero_frame > 41) {
					hero_frame--;
					hero_cycles = 4;
				}
			}
			else {
				if (hero_frame == 43) {
					hero_action = 0;
					hero_frame = 0;
					hero_cycles = 12;
					hero_difframe = 1;
				}
				if (hero_cycles == 0 && hero_frame < 43) {
					hero_frame++;
					hero_cycles = 6;
				}
			}
		}
		else {
			if (kd_down == 0) {
				hero_action = 6;
				hero_cycles = 6;
			}
			if (hero_dir == 0 && kd_left == 1) {
				hero_dir = 1;
				hero_x -= 50;
			}
			if (hero_dir == 1 && kd_right == 1) {
				hero_dir = 0;
				hero_x += 50;
			}
			chkaction(5);
		}
	}

	if (hero_action == 3 || hero_action == 4) {
		if (hero_wcycles == 0) chkaction(5);
		if (hero_wcycles > 0) hero_wframe = hero_frame;
		if (command == 1 && hero_cjdir == 0 && !(hero_jdir == 1) && hero_wcycles == 0) {
			if (hero_jdir == 2)	hero_jdir = 1;
			hero_dir = 1;
			hero_cjdir = 1;
		}
		if (command == 2 && hero_cjdir == 0 && !(hero_jdir == 0) && hero_wcycles == 0) {
			if (hero_jdir == 2) hero_jdir = 0;
			hero_dir = 0;
			hero_cjdir = 1;
		}
		if (hero_phase < 9) hero_cycles--;

		hero_y += hero_jsped/10;
		hero_jsped += 15;

		if (hero_cycles == 0 && hero_phase < 9) {
			if (hero_phase == 0 || hero_phase == 5) {
				hero_cycles = 3;
				hero_frame = 19;
			}
			if (hero_phase == 1 || hero_phase == 4) {
				hero_cycles = 4;
				hero_frame = 18;
			}
			if (hero_phase == 2) {
				hero_cycles = 6;
				hero_frame = 20;
			}
			if (hero_phase == 3) {
				hero_cycles = 8;
			}
			if (hero_phase == 6 || hero_phase == 7) {
				hero_cycles = 18;
				hero_frame = 40;
			}
			hero_phase++;
			if (hero_phase == 9) hero_frame = 40;
		}
		if (hero_action == 4) hero_x += 12*(1-2*hero_jdir);
		if (hero_jdir < 2 && hero_action == 3 && hero_phase < 7)
			hero_x += 6*(1-2*hero_jdir);

		if (hero_jdir == 0 && (onblock(hero_x+235, hero_x+235, hero_y+480,0) == 0)) {					
			if (inblock(hero_x+320, hero_y+20, hero_y+440,0) > 0) {
				hero_x = ((hero_x+screen_px)/240)*240+150-screen_px;
				if (hero_action == 3) hero_cjdir = 0;
			}
			/*if (inblock(hero_x+320, hero_y+440, hero_y+450,1) > 0) {
				hero_x = ((hero_x+screen_px)/240)*240+150-screen_px;
				if (hero_action == 3) hero_cjdir = 0;
			}*/
		}
		if (hero_jdir == 1 && (onblock(hero_x+235, hero_x+235, hero_y+480,0) == 0)) {
			if (inblock(hero_x+140, hero_y+20, hero_y+440,0) > 0) {
				hero_x = ((hero_x+screen_px)/240)*240+110-screen_px;
				if (hero_action == 3) hero_cjdir = 0;
			}
			/*if (inblock(hero_x+140, hero_y+440, hero_y+450,1) > 0) {
				hero_x = ((hero_x+screen_px)/240)*240+110-screen_px;
				if (hero_action == 3) hero_cjdir = 0;
			}*/
		}

		if (hero_jsped > 0) {
					
			if (onblock(hero_x+150, hero_x+320, hero_y+480,0) > 0) {
				if (ob_onobj > 0) {
					hero_onobj = ob_onobj;
					hero_ontype = ob_ontype;

					if (hero_ontype == 1)
						hero_y = platforms[pend_plat[hero_onobj-1]].y-screen_py-480;
					if (hero_ontype == 3)
						hero_y = platforms[crush_plat[hero_onobj-1]].y-screen_py-480;
				}
				else {
					hero_y = ((hero_y+screen_py)/240)*240-screen_py;
				}
				hero_action = 0;
				hero_frame = 0;
				hero_cycles = 12;
				if (hero_jsped > 650) {
					hero_cycles = 15;
					hero_frame = 41;
					FSOUND_PlaySound (FSOUND_FREE, FX_thud);
					hero_action = 2;
					if (hero_wcycles > 0) hero_wframe = 35+hero_wphase;

					if (debris_number == 200) debris_number--;
					db[debris_number].dtype = 8;		// dust
					db[debris_number].x = hero_x - 10 + hero_dir * 270;
					db[debris_number].y = hero_y + 340;
					db[debris_number].speed = 20;
					db[debris_number].dur = 48;
					db[debris_number].cycles = 8;
					db[debris_number].phase = 0;
					db[debris_number].dir = 1-hero_dir;
					debris_number++;

				}
				hero_cjdir = 0;
					
				for (i=0;i<n_roto;i++) {
					if (roto_cycles[i] == 0 && hero_y+screen_py == roto_y[i]-480) {
						if ((hero_x+screen_px)+250 > roto_x[i] 
							&& (hero_x+screen_px)+260 < roto_x[i]+520) {
								roto_cycles[i] = 15;
						}
					}
				}
			}
					
		}		
				
		if (hero_onobj > 0 && hero_ontype == 0) {
			if (hero_x < stairs_x[hero_onobj-1] || hero_x > stairs_x[hero_onobj-1]
				+(stairs_top[hero_onobj-1]-stairs_y[hero_onobj-1])) hero_onobj = 0;
		}		
				
		if (hero_wcycles > 0) hero_frame = hero_wframe;
	}

	if (hero_action == 5) {
		if (kd_up != 1 && command != 4) {
			hero_action = 0;
			hero_frame = 0;
			hero_cycles = 12;
			hero_difframe = 1;
		}
		chkaction(6);
		chkaction(3);
	}

	for (i=0;i<n_sblock;i++) {
		if (sblock_t[i] == 0) {
			if (hero_onobj == 0 && hero_inv == 0 && hero_hp > 0) {
				if (RectsOverlap(hero_rect[0],hero_rect[1],hero_rect[2],hero_rect[3],
					sblock_x[i]*240-screen_px,sblock_y[i]*240-screen_py,240,240)) hurthero(16);
			}
		}

		if ((sblock_t[i] == 1 || sblock_t[i] == 2) && sblock_phase[i] < 9) {
			if ((hero_x+140+screen_px)/240 == sblock_x[i] || (hero_x+320+screen_px)/240 == sblock_x[i]) {
				if ((hero_y+480+screen_py)/240 == sblock_y[i]) {
					sblock_cycles[i]++;
					if (sblock_cycles[i] == 18) {
						sblock_cycles[i] = 0;
						sblock_phase[i]++;
						if (sblock_phase[i] == 1 || sblock_phase[i] == 3 || sblock_phase[i] == 5 || sblock_phase[i] == 7 || sblock_phase[i] == 9)
							FSOUND_PlaySound (FSOUND_FREE, FX_crumble[sblock_phase[i]/2]);
						if (sblock_phase[i] == 9) {
							level[sblock_x[i]][sblock_y[i]] = 0;
							if (sblock_t[i] == 1)
								level[sblock_x[i]][sblock_y[i]-1] = 0;
						}
					}
				}
			}
		}
	
	}

	for (i=0;i<n_splat;i++) {
		i2 = splat_p[i];
		splat_p[i] += splat_s[i];
					
		if (splat_p[i] > screen_wy) splat_p[i] = 0;
		if (splat_p[i] < 0) splat_p[i] = screen_wy;
		platforms[splat_plat[i]].move(0,splat_p[i]-i2);
	}

	/*if ((hero_onobj == 0 || hero_ontype != 0) && Bbutton == 0 && hero_action < 50) {
		if (kd_up || (kd_down && hero_action == 2)) {
			for (i=0;i<n_stairs;i++) {
				i2 = 1;
				if (stairs_dir[i] == 0 && hero_dir == 1 && hero_action == 1) i2 = 0;
				if (stairs_dir[i] == 1 && hero_dir == 0 && hero_action == 1) i2 = 0;
				if (i2 == 1) {
					if (stairs_dir[i] == 0) {
						if (hero_x+20 > stairs_x[i] && hero_x-40 < stairs_x[i]+(stairs_y[i]-stairs_top[i])) {
							if (hero_y > stairs_y[i]-(hero_x-stairs_x[i])-30 && hero_y < stairs_y[i]-(hero_x-stairs_x[i])+30) {
								hero_y = stairs_y[i]-(hero_x-stairs_x[i]);
								hero_action = 0;
								hero_frame = 0;
								hero_cycles = 12;
								hero_difframe = 1;
								hero_hittype = 0;
								hero_onobj = i+1;
								hero_ontype = 0;
								if (hero_dir == 1) hero_y -= 70;
							}
						}
					}
					else {
						if (hero_x < stairs_x[i]+10 && hero_x > stairs_x[i]-(stairs_y[i]-stairs_top[i])-10) {
							if (hero_y > stairs_y[i]-(stairs_x[i]-hero_x)-30 && hero_y < stairs_y[i]-(stairs_x[i]-hero_x)+30) {
								hero_y = stairs_y[i]-(stairs_x[i]-hero_x);
								hero_action = 0;
								hero_frame = 0;
								hero_cycles = 12;
								hero_difframe = 1;
								hero_hittype = 0;
								hero_onobj = i+1;
								hero_ontype = 0;
								if (hero_dir == 0) hero_y -= 70;
													
							}
						}
					}
				}				
			}
		}
	}*/

	if (hero_wcycles > 0 && hero_action < 50) {
		hero_wcycles--;
		if (hero_wcycles == 0) {
			if (hero_wphase < 5) {
				hero_wphase++;
				if (hero_frame == 30) hero_frame = 22;
				if (hero_wphase != 4) hero_frame++;
				if (hero_wphase == 3 && hero_throw == 1) hero_frame = 27;
				if (hero_frame == 27 && hero_onobj > 0 && hero_ontype == 0) {
					if (hero_oldcframe == 48) hero_frame = 65;
					if (hero_oldcframe == 51) hero_frame = 83;
					if (hero_oldcframe == 54) hero_frame = 92;
					if (hero_oldcframe == 57) hero_frame = 74;
				}

				hero_wcycles = 4;
				if (hero_wphase == 5) hero_wcycles = 8;
				if (hero_throw == 0) 
					if (hero_wphase == 3 || hero_wphase == 4) hero_wcycles = 3;				
				
				if (hero_throw == 1 && hero_wphase == 3) {
					sub_x[n_sub] = hero_x + 300;
					if (hero_weapon == 5) {
						sub_x[n_sub] = sub_x[n_sub] + 100;
						shadow_cycles[n_sub] = 0;
					}
					if (hero_weapon == 3 && hero_dir == 1)
						sub_x[n_sub] = sub_x[n_sub] + 160;
					sub_extra[n_sub] = 0;
					if (hero_dir == 1) sub_x[n_sub] -= 350;
					sub_y[n_sub] = hero_y + 150;
			
					if (hero_weapon == 4) sub_y[n_sub] -= 380;

					sub_dir[n_sub] = hero_dir;
					sub_cycles[n_sub] = 0;
					sub_phase[n_sub] = 0;
					sub_type[n_sub] = hero_weapon;
				
					if (sub_type[n_sub] == 4 && sub_dir[n_sub]) sub_phase[n_sub] = 26;

					sub_kills[n_sub] = 0;
					n_sub++;
							
					if (hero_weapon == 2) {
						FSOUND_PlaySound (FSOUND_FREE, FX_brang); //!!!! brang
						if (hero_double > 0) {
							sub_x[n_sub] = hero_x + 300 - (1-2*hero_dir)*100;
							if (hero_dir == 1) sub_x[n_sub] -= 350;
							sub_y[n_sub] = hero_y + 150;
							sub_dir[n_sub] = hero_dir;
							sub_cycles[n_sub] = 0;
							sub_phase[n_sub] = 0;
							sub_type[n_sub] = hero_weapon;
							sub_kills[n_sub] = 0;
							sub_extra[n_sub] = -8;
							n_sub++;
						}
						if (hero_double == 2) {
							sub_x[n_sub] = hero_x + 300 - (1-2*hero_dir)*200;
							if (hero_dir == 1) sub_x[n_sub] -= 350;
							sub_y[n_sub] = hero_y + 150;
							sub_dir[n_sub] = hero_dir;
							sub_cycles[n_sub] = 0;
							sub_phase[n_sub] = 0;
							sub_type[n_sub] = hero_weapon;
							sub_kills[n_sub] = 0;
							sub_extra[n_sub] = 8;
							n_sub++;
						}
					}
					if (hero_weapon == 3) FSOUND_PlaySound (FSOUND_FREE, FX_axe);

				}
			}
			else {				
				if (hero_action == 0) {
					hero_frame = 0;
					hero_cycles = 12;
					hero_difframe = 1;
				}
				if (hero_action == 2) {
					hero_frame = 41;
					hero_cycles = 0;
				}
				if (hero_action > 2) hero_frame = 29;

				if (hero_onobj > 0 && hero_ontype == 0) {
					if (hero_throw > 0) {
						if (hero_oldcframe == 48) hero_frame = 58;
						if (hero_oldcframe == 51) hero_frame = 76;
						if (hero_oldcframe == 54) hero_frame = 76;
						if (hero_oldcframe == 57) hero_frame = 67;
						hero_climb = -103;	
					}
					else {
						hero_frame = hero_oldcframe;
						Bbutton = 0;
					}
					hero_action = 1;
				}
				hero_throw = 0;
			}
		}
	}

	if (hcycles > 0) {
		hcycles--;
		if (hcycles == 0) {
			hearts[0]++;
			hboost--;
			if (hboost > 0) hcycles = 3;
		}

		if (hearts[0] > 9) {
			hearts[0] -= 10;
			hearts[1]++;
		}
		if (hearts[1] > 9) { hearts[0] = 9; hearts[1] = 9; }
	}

	if (hero_lcycles > 0) {
		hero_lcycles--;
		if (hero_lcycles == 0) {
			//hero_hp += hero_hdif;
			hero_losehp--;
			if (hero_losehp > 0)
				if (hero_lhpdif == -1) hero_lcycles = 5; else hero_lcycles = 2;
			//if (hero_hp == 16) hero_lcycles = 0;
		}
		
		/*if (hero_hp < 1) {
			hero_hp = 0;
			hero_frame = 45;
			hero_inv = 0;
		}*/
	}
	if (hero_action == 7) {
		if (hero_phase < 7 || hero_phase > 22) {
			hero_y += 20*hero_difframe;
		}
		else {
			hero_y += 5*hero_difframe;
		}
		if (hero_phase > 32) hero_y += 15;
		hero_x += 15*(-1+2*hero_jdir);
		hero_phase++;
		if (hero_phase == 15) hero_difframe = 1;
		if (hero_jdir == 1) {
			if (inblock(hero_x+320, hero_y+40, hero_y+440, 0) > 0) {
				hero_x = ((hero_x+screen_px)/240)*240+150-screen_px;
			}
		}
		if (hero_jdir == 0) {
			if (inblock(hero_x+140, hero_y+40, hero_y+440, 0) > 0) {
				hero_x = ((hero_x+screen_px)/240)*240+110-screen_px;
			}
		}

		if (hero_difframe == 1)
		if (onblock(hero_x+150, hero_x+320, hero_y+480,0) > 0) {
			if (ob_onobj > 0) {
				hero_onobj = ob_onobj;
				hero_ontype = ob_ontype;

				if (hero_ontype == 1)
					hero_y = platforms[pend_plat[hero_onobj-1]].y-screen_py-480;
				if (hero_ontype == 3)
					hero_y = platforms[crush_plat[hero_onobj-1]].y-screen_py-480;
			}
			else hero_y = ((hero_y+screen_py)/240)*240-screen_py;
			hero_action = 0;
			hero_frame = 0;
			hero_cycles = 12;
			hero_difframe = 1;
			hero_hittype = 0;
			for (i=0;i<n_roto;i++) {
				if (roto_cycles[i] == 0 && hero_y+screen_py == roto_y[i]-480) {
					if ((hero_x+screen_px)+250 > roto_x[i] && (hero_x+screen_px)+260 < roto_x[i]+520)
						roto_cycles[i] = 15;					
				}
			}
		}

	}
	
	if (hero_inv > 0) {
		hero_iphase++;
		if (hero_iphase == inv_dur) {
			hero_inv = 0;
			if (freeze == 1) {
				freeze = 0;
				hero_action -= 50;
				hero_whip++;
				if (oldinv > 0) {
					hero_inv = 1;
					hero_iphase = oldinv;
					inv_dur = olddur;
					oldinv = 0;
				}
			}
		}
		hero_icycles--;
		if (hero_icycles == 0) {
			if (hero_inv == 1) hero_icycles = 3; else hero_icycles = 5;
			if (hero_hittype > 0) hero_icycles = 7;
			if (freeze == 1) hero_icycles = 1;
			hero_inv = 3 - hero_inv;
		}		
	}

	if (door_action == 0 || door_action == 7) {
		do {
			scroll(10);
		}
		while (hero_x > 1400 && screen_px < screen_wx-3200);
		do {
			scroll(-10);
		}
		while (hero_x < 1350 && screen_px > sleft);
	}
	
	do {
		yscroll(10);
		fogy1 -= 10;
		fogy2 -= 6;
	}
	while (hero_y > 1320 && screen_py < screen_wy-2400);
	do {
		yscroll(-10);
		fogy1 += 10;
		fogy2 += 6;
	}
	while (hero_y < 820 && screen_py > -60);

	hero_rect[0] = hero_x + 120;
	hero_rect[1] = hero_y + 20;
	hero_rect[2] = 200;
	hero_rect[3] = 460;
	if (hero_dir == 1) hero_rect[0] = hero_x + 140;
	if (hero_action == 2 || hero_action == 6) {
		hero_rect[1] = hero_y + 190;
		hero_rect[3] = 290;
	}
	if (hero_frame > 17 && hero_frame < 21) hero_rect[3] = 310;
	if (hero_wcycles > 0 && hero_throw == 0 && hero_wphase == 4) {
	/*	if (hero_wphase == 3) {
			hero_wrect[0] = hero_x - 20;
			hero_wrect[1] = hero_y - 60;
			hero_wrect[2] = 480;
			hero_wrect[3] = 200;
		}*/
		//if (hero_wphase == 4) { // || hero_wphase == 5) {
			hero_wrect[0] = hero_x + 260;
			hero_wrect[1] = hero_y + 120;
			hero_wrect[2] = 580;
			hero_wrect[3] = 100;
		//}
		if (hero_whip == 2) hero_wrect[2] += 220;
		if (hero_dir == 1) hero_wrect[0] = hero_x+460-(hero_wrect[0]-hero_x)-hero_wrect[2];
		if (hero_action == 2) {
			hero_wrect[1] += 170;
			if (hero_dir == 0)
				hero_wrect[0] -= 50;
			else
				hero_wrect[0] += 50;			
		}				
	}

	for (i=0;i<n_roto;i++) {
		if (roto_cycles[i] > 0) {
			roto_cycles[i]--;
			if (roto_cycles[i] == 0) {
				roto_phase[i]++;
				if (roto_phase[i] == 1) {
					platforms[roto_plat[i]].enable(false);
					FSOUND_PlaySound (FSOUND_FREE, FX_rblock);
				}
				if (roto_phase[i] < 23)
					roto_cycles[i] = 1;
				else {
					platforms[roto_plat[i]].enable(true);
					roto_phase[i] = 0;
					if (roto_spikes[i] > 0) roto_spikes[i] = 3-roto_spikes[i];
				}
			}	
		}
	}

	for (i=0;i<n_gears;i++) {
		gear_apos[i] += gear_s[i];
		if (gear_apos[i] > 3599) gear_apos[i] -= 3600;
		if (gear_apos[i] < 0) gear_apos[i] += 3600;

		if (hero_onobj == i+1 && hero_ontype == 2) {
			if (gear_t[i] == 0)
				hero_x += (int)(gear_s[i]*1.6f);
			else hero_x += (int)(gear_s[i]/1.3f);
			if (gear_t[i] == 0) i3 = 950; else i3 = 460;
			i2 = (int)(cos(asin((float)(gear_x[i] - (hero_x+240) - screen_px)
				/(float)i3))*i3);
			hero_y = gear_y[i] - i2 - screen_py - 480;

			if (hero_x+280 < gear_x[i] - screen_px - i3/1.1f) {
				hero_x -= 20; hero_onobj = 0; }
			if (hero_x+200 > gear_x[i] - screen_px + i3/1.1f) {
				hero_x += 20; hero_onobj = 0; }

		}
	}

	for (i=0;i<n_pend;i++) {
		if (pend_pos[i] > 0)
			pend_dif[i]--;
		else
			pend_dif[i]++;
		pend_pos[i] += pend_dif[i] * pend_s[i];

		i2 = pend_cx[i];
		i3 = pend_cy[i];
		pend_cx[i] = pend_x[i]+(int)(sin((float)pend_pos[i]/18000.0f*3.14159f)*pend_l[i])*10;
		pend_cy[i] = pend_y[i]+(int)(cos((float)pend_pos[i]/18000.0f*3.14159f)*pend_l[i])*10;

		platforms[pend_plat[i]].move(pend_cx[i] - i2, pend_cy[i] - i3);
	}

	for (i=0;i<n_crush;i++) {
		i2 = crush_p[i];
		if (hero_action < 50) crush_p[i] += crush_d[i];
		if (crush_p[i] < 1) {
			crush_p[i] = 0;
			crush_d[i] = 60;
		}
		if (crush_p[i] > (crush_h[i]-1)*240) {
			crush_p[i] = (crush_h[i]-1)*240;
			crush_d[i] = -6;
		}
		platforms[crush_plat[i]].move(0,crush_p[i]-i2);

		if (hero_inv == 0) {
			if (RectsOverlap(hero_rect[0],hero_rect[1],hero_rect[2],hero_rect[3],
				crush_x[i]*240-screen_px,
				crush_y[i]*240-screen_py-240*crush_h[i]+crush_p[i]+260,
				480, 120))
				
			{
				hurthero(16);
			}
		}
	}

	if (door_action == 0) {
		for (i=0;i<n_doors;i++) {
			if (door_valid[i] == 1) {
			
				if (hero_x+screen_px > door_x[i]-450 && hero_x+screen_px < door_x[i]+150 && hero_y+screen_py > door_y[i] && hero_y+screen_py < door_y[i]+720) {
					door_action = 1;
					door_cycles = 15;
					door_phase = 0;
					freeze = 1;
					if (hero_x+screen_px < door_x[i])
						hero_dir = 0;
					else hero_dir = 1;
					hero_inv = 0;
					exitdoor = i+1;

					for (i2=0;i2<enemy_number;i2++) if (e[i].etype > 9) e[i].hp = 0;
				}
			}
		}
	}
	if (door_cycles > 0) door_cycles--;
	if (door_action == 1) {
		if (door_cycles == 0) {
			door_phase++;
			door_cycles = 3;
			if (door_phase == 1) FSOUND_PlaySound (FSOUND_FREE, FX_dooropen);
			if (door_phase == 12) { door_action = 3; door_cycles = 57; }
		}
	}
	
	if (door_action == 3) {
		if (door_cycles == 0) {
			door_action = 4;
			door_cycles = 2;
		}
	}
	
	if (door_action == 4) {
		if (door_cycles == 0) {
			door_phase--;
			door_cycles = 2;
			if (door_phase == 0) {
				door_action = 0;
				FSOUND_PlaySound (FSOUND_FREE, FX_doorslam);
				freeze = 0;
				exitdoor = 0;
			}
		}
	}

	if (door_action == 6) {
		if (door_cycles == 21) {
			f_action = 2;
			f_phase = 15;
		}
		if (door_cycles == 0) {
			if (exitdoor > 0)
				sprintf(oldlevel, levelname);
			return(true);
		}
	}
	if (door_action == 7) {
		if (door_cycles == 0) {
			door_action = 0;
			freeze = 0;
		}
	}

	if (door_action == 0 || door_action == 3) {
		if (hero_x > 2860) {
			for (i=0;i<n_exit;i++) {
				if (exit_dir[i] == 1 && hero_y+screen_py-1 < exit_p2[i] && hero_y+screen_py+1 > exit_p1[i]) {
					door_action = 6;
					freeze = 1;
					door_cycles = 30;					
					sprintf(levelname, exit_file[i]);
					hero_dir = 0;
					enterat = exit_entry[i];
				}				
			}
		}
		
		if (hero_x < -120) {
			for (i=0;i<n_exit;i++) {
				if (exit_dir[i] == 3 && hero_y+screen_py-1 < exit_p2[i] && hero_y+screen_py+1 > exit_p1[i]) {
					door_action = 6;
					freeze = 1;
					door_cycles = 30;
					sprintf(levelname, exit_file[i]);
					hero_dir = 1;
					enterat = exit_entry[i];
				}
			}
		}
		
		if (hero_y > 1850) {
			for (i=0;i<n_exit;i++) {
				if (exit_dir[i] == 2 && hero_x+screen_px-1 < exit_p2[i] && hero_x+screen_px+1 > exit_p1[i] && (hero_onobj > 0 && hero_ontype == 0)) {
					door_action = 6;
					freeze = 1;
					door_cycles = 30;
					hero_dir = 1-stairs_dir[hero_onobj-1];
					sprintf(levelname, exit_file[i]);
					enterat = exit_entry[i];
				}
			}
		}
		
		if (hero_y < 260) {
			for (i=0;i<n_exit;i++) {
				if (exit_dir[i] == 0 && hero_x+screen_px-1 < exit_p2[i] && hero_x+screen_px+1 > exit_p1[i] && (hero_onobj > 0 && hero_ontype == 0)) {
					door_action = 6;
					freeze = 1;
					door_cycles = 30;
					hero_dir = stairs_dir[hero_onobj-1];
					sprintf(levelname, exit_file[i]);
					enterat = exit_entry[i];
				}
			}
		}				
	}

	if (hero_frame == 45) {
		hero_phase = 1;
		hero_jsped = -260;
		hero_difframe = 100;
		hero_hdif = 0;
	}
	if (hero_y > 2370) {
		hero_phase = 0;
		hero_frame = 45;
	}

/*	If KeyDown(25)
		PauseChannel(channel1)
		
		Flip
		DrawImage font,125,108,15
		DrawImage font,141,108,0
		DrawImage font,157,108,20
		DrawImage font,173,108,18
		DrawImage font,189,108,4
		Flip
		
		FSOUND_PlaySound (FSOUND_FREE, s_pause)		
		Delay(250)
		While (Not KeyDown(25))
			
		Wend		
		ResumeChannel(channel1)
		Delay(250)
	EndIf*/		

	return(false);
}