void Handle_Items(void)
{
	int n_del, isdel;

	blink_cycles--;
	if (blink_cycles == 0) { blink_cycles = 4; blink_phase = 1-blink_phase; }

	n_del = 0;
	for (i=0;i<item_number;i++) {
		if (freeze == 0 || freeze == 2) {
			if (it[i].falling == 1 && it[i].itype > 0) {
				it[i].y += 22;
				if (onblock(it[i].x+it[i].rect1,it[i].x+it[i].rect1+it[i].rect3,it[i].y+it[i].rect2+it[i].rect4-10,1) == 1) {
					it[i].y = ((it[i].y+screen_py)/240)*240-screen_py;
					it[i].falling = 0;
					it[i].dur = 180;
				}				
			}
			if (it[i].falling == 1 && it[i].itype == 0) {
				it[i].y += 2;
				it[i].x += 2*h_dir[i];
				if (h_cycles[i] < 50 && h_cycles[i] > 10) it[i].x += 3*h_dir[i];
				h_cycles[i]++;
				if (h_cycles[i] == 60) { h_cycles[i] = 0; h_dir[i] *= -1; }
				if (onblock(it[i].x+it[i].rect1,it[i].x+it[i].rect1+it[i].rect3,it[i].y+it[i].rect2+it[i].rect4-10,1) == 1) {
					it[i].y = ((it[i].y+screen_py)/240)*240-screen_py;
					it[i].falling = 0;
					it[i].dur = 180;
					h_cycles[i] = 30;
				}
			}
		}

		if (it[i].itype < 2) {
			it[i].cycles--;
			if (it[i].cycles == 0) {
				it[i].phase = 1-it[i].phase;
				it[i].cycles = 12;
			}
		}
		if (it[i].itype > 1 && it[i].itype < 10) {
			it[i].cycles--;
			if (it[i].cycles == 0) {
				it[i].phase++;
				if (it[i].phase > 2) it[i].phase = 0;
				it[i].cycles = 3;
			}				
		}		

		isdel = 0;
		if (it[i].dur > 0 && (freeze == 0 || freeze == 2)) {
			it[i].dur--;
			if (it[i].dur == 0) {
				if (it[i].itype == 19) crest_out = 0;
				del[n_del] = i;
				n_del++;
				isdel = 1;
			}
		}		
		
		if (isdel == 0) {
			if (RectsOverlap(hero_rect[0],hero_rect[1],hero_rect[2],hero_rect[3],it[i].rect1+it[i].x,it[i].rect2+it[i].y,it[i].rect3,it[i].rect4)) {
				if (it[i].itype < 2) {
					if (it[i].itype == 0) {
						hearts[0]++;
						FSOUND_PlaySound (FSOUND_FREE, FX_sheart);
					}
					else {
						hboost = 5;
						hcycles = 3;
						FSOUND_PlaySound (FSOUND_FREE, FX_lheart);
					}
					if (hearts[0] > 9) {
						hearts[0] -= 10;
						hearts[1]++;
					}
					if (hearts[1] > 9) { hearts[0] = 9; hearts[1] = 9; }
				}
				if (it[i].itype > 1 && it[i].itype < 10) {
					hero_weapon = it[i].itype;
					hero_double = 0;
					subkills = 0;
					FSOUND_PlaySound (FSOUND_FREE, FX_weaponpick);
				}
				
				if (it[i].itype > 9 && it[i].itype < 16) {
					FSOUND_PlaySound (FSOUND_FREE, FX_money);
					
					if (debris_number == 200) debris_number--;
					db[debris_number].dtype = 5;							// score
					db[debris_number].x = it[i].x+50;
					db[debris_number].y = it[i].y+100;
					db[debris_number].phase = 2;
					db[debris_number].cycles = 0;
										
					if (it[i].itype == 10) { inc_score(0,0,1,0,0); db[debris_number].type2 = 1; }
					if (it[i].itype == 11) { inc_score(0,0,2,0,0); db[debris_number].type2 = 2; }
					if (it[i].itype == 12) { inc_score(0,0,4,0,0); db[debris_number].type2 = 4; }
					if (it[i].itype == 13) { inc_score(0,0,7,0,0); db[debris_number].type2 = 7; }
					if (it[i].itype == 14) {
						inc_score(0,1,0,0,0);
						db[debris_number].type2 = 1;
						db[debris_number].phase = 3;
					}

					debris_number++;					
				}
				if (it[i].itype == 19) {
					if (hero_whip == 0) kills = 1;
					crest_out = 0;
					FSOUND_PlaySound (FSOUND_FREE, FX_crest);
					if (hero_inv == 1) {
						oldinv = hero_icycles;
						olddur = inv_dur;
					}
					hero_inv = 1;
					hero_icycles = 6;
					hero_iphase = 0;					
					inv_dur = 60;
					freeze = 1;
					hero_action += 50;
				}
				if (it[i].itype == 20) {
					FSOUND_PlaySound (FSOUND_FREE, FX_rosary);
					for (i2=0;i2<enemy_number;i2++)
						if (e[i2].etype > 9) e[i2].hp = 0;					
				}
				
				if (it[i].itype == 23) {
					//!!! sound
					players[0]++;
					if (players[0] > 9) {
						players[0] -= 10;
						players[1]++;
					}
				}
				
				if (it[i].itype == 16) {
					if (hero_weapon > 0) hero_double = 1;
					FSOUND_PlaySound (FSOUND_FREE, FX_double);
				}
				if (it[i].itype == 17) {
					if (hero_weapon > 0) hero_double = 2;
					FSOUND_PlaySound (FSOUND_FREE, FX_double);
				}
				if (it[i].itype == 18) {
					FSOUND_PlaySound (FSOUND_FREE, FX_meat);
					if (hero_hp < 16) {
						hero_losehp = 8;
						if (hero_hp > 8)
							hero_losehp = 16 - hero_hp;
						hero_lcycles = 2;
						hero_lhpdif = 1;
						hero_hp += hero_losehp;
					}
					else {
						inc_score(0,1,0,0,0);

						if (debris_number == 200) debris_number--;
						db[debris_number].dtype = 5;							// score
						db[debris_number].x = it[i].x+50;
						db[debris_number].y = it[i].y+100;
						db[debris_number].type2 = 1;
						db[debris_number].phase = 3;
						db[debris_number].cycles = 0;
						debris_number++;
					}
				}
				del[n_del] = i;
				n_del++;
			}
		}
	}

	i2 = n_del-1;
	while (i2 > -1) {
		for (i3=del[i2];i3<item_number-1;i3++) {
			it[i3].x = it[i3+1].x; it[i3].y = it[i3+1].y;
			it[i3].itype = it[i3+1].itype;
			it[i3].rect1 = it[i3+1].rect1; it[i3].rect2 = it[i3+1].rect2;
			it[i3].rect3 = it[i3+1].rect3; it[i3].rect4 = it[i3+1].rect4;
			it[i3].phase = it[i3+1].phase; it[i3].cycles = it[i3+1].cycles;
			it[i3].falling = it[i3+1].falling;
			it[i3].dur = it[i3+1].dur;	
			h_cycles[i3] = h_cycles[i3+1];
			h_dir[i3] = h_dir[i3+1];
		}

		item_number--;
		i2--;
	}
}