bool readlevel(void)
{
	char fname[255];
	FILE *file1;
	byte readb;
	short int nttile, fheight, fwidth, fnum, reads;
	int i, i2, slen, bgmask1, readi, blanks, bgpic1, testpos;
	D3DCOLOR bgmask;
    
	sprintf(fname, "levels\\%s",levelname);
	file1 = fopen(fname,"rb");

	if (!file1) return(false);

	for (i=0;i<5;i++) {
		fread(&reads,2,1,file1);
		if (reads != 0) return(false);
	}
	fread(&reads,2,1,file1);
	if (reads != 54) return(false);

	fread(&num_ftiles,2,1,file1);
	for (i=0;i<num_ftiles;i++) {
		fread(&fnum,2,1,file1);
		sprintf(fname, "tiles\\tile");
		if (fnum < 1000) sprintf(fname,"%s0",fname);
		if (fnum < 100) sprintf(fname,"%s0",fname);
		if (fnum < 10) sprintf(fname,"%s0",fname);
		sprintf(fname,"%s%d.png",fname,fnum);
		tiles[i].Create(fname,0xFFFFFFFF,24,24);
	}

	fread(&readb,1,1,file1);
	num_fstairs = readb;
	for (i=0;i<num_fstairs;i++) {
		fread(&readb,1,1,file1);
		fnum = readb;
		sprintf(fname, "tiles\\stair");
		if (fnum < 1000) sprintf(fname,"%s0",fname);
		if (fnum < 100) sprintf(fname,"%s0",fname);
		if (fnum < 10) sprintf(fname,"%s0",fname);
		sprintf(fname,"%s%d.png",fname,fnum);
		stairs[i].Create(fname,0xFFFFFFFF,24,24);
	}

	fread(&readi,4,1,file1);
	screen_px = readi;
	fread(&readi,4,1,file1);
	screen_py = readi;
	fread(&readi,4,1,file1);
	screen_wx = readi;
	fread(&readi,4,1,file1);
	screen_wy = readi;

	fread(&reads,2,1,file1);
	tbsx[1] = reads;
	fread(&reads,2,1,file1);
	tbsy[1] = reads;
	
	fread(&readb,1,1,file1);
	n_exit = readb;
	for (i=0;i<n_exit;i++) {
		fread(&exit_p1[i],4,1,file1);
		fread(&exit_p2[i],4,1,file1);
		fread(&readb,1,1,file1);
		exit_dir[i] = readb;
		fread(&readb,1,1,file1);
		exit_entry[i] = readb;
		fread(&slen,4,1,file1);
		ZeroMemory(exit_file[i], 10);
		for (i2=0;i2<slen;i2++) {
			fread(&readb,1,1,file1);			
			exit_file[i][i2] = readb;
		}
	}

	fread(&readb,1,1,file1);
	n_entry = readb;
	for (i=0;i<n_entry;i++) {
		fread(&entry_x[i],4,1,file1);
		fread(&entry_y[i],4,1,file1);
		fread(&readb,1,1,file1);
		entry_type[i] = readb;
		fread(&readb,1,1,file1);
		entry_dir[i] = readb;
	}

	fread(&reads,2,1,file1);
	nttile = reads;
	for (i=0;i<nttile;i++) {
		fread(&t[i].pic,4,1,file1);
		fread(&readb,1,1,file1);
		t[i].top = readb;
		fread(&readb,1,1,file1);
		t[i].side = readb;
		fread(&t[i].stair,4,1,file1);
	}

	rotoindex = nttile;
	t[rotoindex].side = 0;
	t[rotoindex].pic = -1;
	t[rotoindex].stair = -1;
	t[rotoindex].top = 1;

	fread(&reads,2,1,file1);
	candle_type = reads;

	fread(&reads,2,1,file1);
	nbx = reads;
	fread(&reads,2,1,file1);
	nby = reads;

	i = 0;
	i2 = 0;
	fread(&reads,2,1,file1);
	blanks = reads;
	do {
		if (blanks == 0) {
			fread(&readb,1,1,file1);
			level[i][i2] = readb;
			fread(&reads,2,1,file1);
			blanks = reads;
		}
		else {
			blanks--;
			level[i][i2] = 0;
		}
		i++;
		if (i > nbx) {
			i = 0;
			i2++;
		}
	} while (i2 <= nby);

	nbx++;
	for (i=0;i<=nby;i++) level[nbx][i] = 1;
	
	fread(&reads,2,1,file1);
	bnbx[1] = reads;
	fread(&reads,2,1,file1);
	bnby[1] = reads;
	i = 0;
	i2 = 0;
	fread(&reads,2,1,file1);
	blanks = reads;
	do {
		if (blanks == 0) {
			fread(&readb,1,1,file1);
			bgB[i][i2] = readb;
			fread(&reads,2,1,file1);
			blanks = reads;
		}
		else {
			blanks--;
			bgB[i][i2] = -1;
		}
		i++;
		if (i > bnbx[1]) {
			i = 0;
			i2++;
		}
	} while (i2 <= bnby[1]);

		

	fread(&readb,1,1,file1);
	n_bg = readb;
	for (i=0;i<n_bg;i++) {
		fread(&bgx[i],4,1,file1);
		fread(&bgy[i],4,1,file1);
		fread(&reads,2,1,file1);
		bgsx[i] = reads;
		fread(&reads,2,1,file1);
		bgsy[i] = reads;
		fread(&readb,1,1,file1);
		bgpic1 = readb;
		fread(&readb,1,1,file1);
		bgmask1 = readb;
		fread(&reads,2,1,file1);
		fwidth = reads;
		fread(&reads,2,1,file1);
		fheight = reads;
		fread(&reads,2,1,file1);
		bgloop[i] = reads;

		sprintf(fname, "bg\\bg");
		if (bgpic1 < 1000) sprintf(fname,"%s0",fname);
		if (bgpic1 < 100) sprintf(fname,"%s0",fname);
		if (bgpic1 < 10) sprintf(fname,"%s0",fname);
		sprintf(fname,"%s%d.png",fname,bgpic1);
		
		backgn[i] = fwidth;
		if (bgmask1 == 0) bgmask = 0xFF000000;
		if (bgmask1 == 1) bgmask = 0xFFFFFFFF;
		if (bgmask1 == 2) bgmask = 0xFFFFFF00;

		backg[i].Create(fname,bgmask,fwidth,fheight,512);
	}

	fread(&reads,2,1,file1);
	n_spawn = reads;
	for(i=0;i<n_spawn;i++) {
		fread(&spawn_x[i],4,1,file1);
		fread(&spawn_y[i],4,1,file1);
		fread(&reads,2,1,file1);
		spawn_type[i] = reads;
		fread(&readb,1,1,file1);
		spawn_dir[i] = readb;
		fread(&readb,1,1,file1);
		spawn_extra[i] = readb;
		spawn_exist[i] = 0;
	}

	fread(&reads,2,1,file1);
	n_zspawn = reads;
	for (i=0;i<n_zspawn;i++) {
		fread(&zspawn_l[i],4,1,file1);
		fread(&zspawn_r[i],4,1,file1);
		fread(&zspawn_y[i],4,1,file1);
		fread(&reads,2,1,file1);
		zspawn_type[i] = reads;
		fread(&readb,1,1,file1);
		zspawn_no[i] = readb;
		fread(&reads,2,1,file1);
		zspawn_dur[i] = reads;
		fread(&zspawn_top[i],4,1,file1);
		fread(&zspawn_bottom[i],4,1,file1);
		fread(&reads,2,1,file1);
		zspawn_extra[i] = reads;
		zspawn_cycles[i] = 1; //zspawn_dur[i];
	}

	fread(&reads,2,1,file1);
	n_stairs = reads;
	for (i=0;i<n_stairs;i++) {
		fread(&stairs_x[i],4,1,file1);
		fread(&stairs_y[i],4,1,file1);
		fread(&stairs_top[i],4,1,file1);
		fread(&readb,1,1,file1);
		stairs_dir[i] = readb;
	}

	for (i=0;i<3;i++) {
		fread(&readb,1,1,file1);
		block[i] = readb;
	}

	fread(&readb,1,1,file1);
	n_doors = readb;
	for (i=0;i<n_doors;i++) {
		fread(&door_x[i],4,1,file1);
		fread(&door_y[i],4,1,file1);
		fread(&readb,1,1,file1);
		door_valid[i] = readb;
		fread(&readb,1,1,file1);
		door_type[i] = readb;
	}

	n_plat = 0;

	fread(&readb,1,1,file1);
	n_roto = readb;
	for (i=0;i<n_roto;i++) {
		fread(&roto_x[i],4,1,file1);
		fread(&roto_y[i],4,1,file1);
		fread(&readb,1,1,file1);
		roto_spikes[i] = readb;
		roto_cycles[i] = 0;
		roto_phase[i] = 0;
		roto_plat[i] = n_plat;
		platforms[n_plat].Create(roto_x[i],roto_y[i],480,-1,0);
		n_plat++;
	}

	fread(&readi,4,1,file1);
	n_ani = readi;
	for (i=0;i<n_ani;i++) {
		fread(&reads,2,1,file1);
		ani_x[i] = reads;
		fread(&reads,2,1,file1);
		ani_y[i] = reads;
		fread(&readb,1,1,file1);
		ani_t[i] = readb;
		fread(&readb,1,1,file1);
		ani_o[i] = readb;
	}
	
	fread(&reads,2,1,file1);
	tbsx[0] = reads;
	fread(&reads,2,1,file1);
	tbsy[0] = reads;
	
	fread(&reads,2,1,file1);
	bnbx[0] = reads;
	fread(&reads,2,1,file1);
	bnby[0] = reads;
	
	i = 0;
	i2 = 0;
	fread(&reads,2,1,file1);
	blanks = reads;
	do {
		if (blanks == 0) {
			fread(&readb,1,1,file1);
			bgA[i][i2] = readb;
			fread(&reads,2,1,file1);
			blanks = reads;
		}
		else {
			blanks--;
			bgA[i][i2] = -1;
		}
		i++;
		if (i > bnbx[0]) {
			i = 0;
			i2++;
		}
	} while (i2 <= bnby[0]);
	
	fread(&reads,2,1,file1);
	ani_speed = reads;

	fread(&n_anit,2,1,file1);
	for (i=0;i<n_anit;i++) {
		fread(&fnum,2,1,file1);
		sprintf(fname, "tiles\\tileani");
		if (fnum < 1000) sprintf(fname,"%s0",fname);
		if (fnum < 100) sprintf(fname,"%s0",fname);
		if (fnum < 10) sprintf(fname,"%s0",fname);
		sprintf(fname,"%s%d.png",fname,fnum);
		anis[i].Create(fname,0xFFFFFFFF,24,24);
	}

	fread(&reads,2,1,file1);
	n_gears = reads;
	for (i=0;i<n_gears;i++) {
		fread(&gear_x[i],4,1,file1);
		fread(&gear_y[i],4,1,file1);
		fread(&readb,1,1,file1);
		gear_t[i] = readb;
		fread(&gear_s[i],4,1,file1);
		fread(&readb,1,1,file1);
		if (readb == 0) { gear_x[i] += 120; gear_y[i] += 120; }
		gear_apos[i] = 0;
	}	
	
	fread(&reads,2,1,file1);
	n_pend = reads;
	for (i=0;i<n_pend;i++) {
		fread(&pend_x[i],4,1,file1);
		fread(&pend_y[i],4,1,file1);
		fread(&reads,2,1,file1);
		pend_l[i] = reads;
		fread(&reads,2,1,file1);
		pend_s[i] = reads;
		fread(&reads,2,1,file1);
		i2 = reads;
		fread(&reads,2,1,file1);
		pend_pos[i] = (reads - 90) * 100;

		testpos = i2 * 100;
		if (pend_pos[i] < 0) testpos *= -1;

		pend_dif[i] = 0;
		while ((testpos > pend_pos[i] && pend_dif[i] < 1) ||
			(testpos < pend_pos[i] && pend_dif[i] > -1)) {
			if (testpos > 0)
				pend_dif[i]--;
			else
				pend_dif[i]++;
			testpos += pend_dif[i] * pend_s[i];
		}

		pend_cx[i] = pend_x[i]+(int)(sin((float)pend_pos[i]/18000.0f*3.14159f)*pend_l[i])*10;
		pend_cy[i] = pend_y[i]+(int)(cos((float)pend_pos[i]/18000.0f*3.14159f)*pend_l[i])*10;

		pend_plat[i] = n_plat;
		platforms[n_plat].Create(pend_cx[i]-45,
			pend_cy[i]-70,330,i,1);
		n_plat++;

	}

	fread(&reads,2,1,file1);
	n_crush = reads;
	for (i=0;i<n_crush;i++) {
		fread(&crush_x[i],4,1,file1);
		fread(&crush_y[i],4,1,file1);
		fread(&reads,2,1,file1);
		crush_h[i] = reads;
		fread(&reads,2,1,file1);
		crush_t[i] = reads;
		fread(&reads,2,1,file1);
		crush_p[i] = reads*10;
		crush_d[i] = -6;

		crush_plat[i] = n_plat;
		platforms[n_plat].Create(crush_x[i]*240,
			(crush_y[i]-crush_h[i])*240+crush_p[i]+240,480,i,3);
		n_plat++;
	}

	for (i=0;i<50;i++) {
		fread(&reads,2,1,file1);
		flag[i] = reads;
	}

	fread(&reads,2,1,file1);
	n_teeter = reads;
	for (i=0;i<n_teeter;i++) {
		fread(&teeter_x[i],4,1,file1);
		fread(&teeter_y[i],4,1,file1);
		fread(&reads,2,1,file1);
		if (reads == 0)
			teeter_r[i] = 450;
		else teeter_r[i] = 3150;
	}

	fread(&reads,2,1,file1);
	n_sblock = reads;
	for (i=0;i<n_sblock;i++) {
		fread(&reads,2,1,file1);
		sblock_x[i] = reads;
		fread(&reads,2,1,file1);
		sblock_y[i] = reads;
		fread(&reads,2,1,file1);
		sblock_t[i] = reads;

		sblock_phase[i] = 0;
		sblock_cycles[i] = 0;
	}

	fread(&reads,2,1,file1);
	n_splat = reads;
	for (i=0;i<n_splat;i++) {
		fread(&splat_x[i],4,1,file1);		
		fread(&reads,2,1,file1);
		splat_p[i] = reads*10;
		fread(&reads,2,1,file1);
		splat_s[i] = reads-100;

		splat_plat[i] = n_plat;
		platforms[n_plat].Create(splat_x[i],splat_p[i],480,i,4);
		n_plat++;
	}
	
	fclose(file1);	

	x_offset = 0;
	y_offset = 0;
	if (flag[1] == 1) {
		sway_cycles = 110;
		sway_phase = 0;
	}

	return(true);
}

void unloadlevel(void)
{
	for (i=0;i<num_ftiles;i++)
		if (tiles[i].tex) tiles[i].tex->Release();

	for (i=0;i<num_fstairs;i++) 
		if (stairs[i].tex) stairs[i].tex->Release();

	for (i=0;i<n_bg;i++)
		if (backg[i].tex) backg[i].tex->Release();

	for (i=0;i<n_anit;i++) 
		if (anis[i].tex) anis[i].tex->Release(); //!!!!!
}