int menu(void)
{
	Sprite SPbg, SPframe, SPfire[2], SPwindow;
	int menu_select, menu_kd, menu_name, menu_mode, menu_ani;
	int sv_names, sv_lname[20], sv_name[20][10], sv_area[20], sv_time[20][6],
		sv_score[20][9], sv_pct[20][4], sv_mode[20], sv_spirit[20], sv_subw[20],
		menu_pos, fire_phase, fire_cycles, selc;
	FILE *file1;
	int x1, x2, x3, x4, x5;
	D3DCOLOR col;

	// load saves
	file1 = fopen("svfile","rb");
	fread(&sv_names,4,1,file1);
	for (i=0;i<sv_names;i++) {
		fread(&sv_lname[i],4,1,file1);
		for (i2=0;i2<sv_lname[i];i2++) fread(&sv_name[i][i2],4,1,file1);
		fread(&sv_area[i],4,1,file1);
		for (i2=0;i2<6;i2++) fread(&sv_time[i][i2],4,1,file1);
		for (i2=0;i2<9;i2++) fread(&sv_score[i][i2],4,1,file1);
		for (i2=0;i2<4;i2++) fread(&sv_pct[i][i2],4,1,file1);
		fread(&sv_mode[i],4,1,file1);
		fread(&sv_spirit[i],4,1,file1);
		fread(&sv_subw[i],4,1,file1);
	}
	fclose(file1);


	SPbg.Create("bg\\bg0018.png", 0, 320, 240);
	SPfire[0].Create("sprites\\menufire.png", 0xFFFF00FF, 16, 16);
	SPfire[1].Create("sprites\\menufire2.png", 0xFFFF00FF, 16, 16);
	SPframe.Create("sprites\\menuholder.png", 0xFFFF00FF, 144, 32);
	SPwindow.Create("sprites\\menuwindow2.png", 0xFF000000, 8, 4, 96);

	x1 = 0; x2 = 0; x3 = 200; x4 = 200, x5 = -200;

	menu_kd = 0;
	menu_select = 0;
	menu_name = 0;
	menu_pos = 0;
	menu_mode = 0;
	menu_ani = 0;

	fire_phase = 0;
	fire_cycles = 0;

	bgmusic = FMUSIC_LoadSong("music\\CV3- Epitaph.mid");
	FMUSIC_PlaySong(bgmusic);

	while (TRUE) { 
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
			if (msg.message == WM_QUIT) {

				SPbg.tex->Release();		
				SPframe.tex->Release();		SPfire[0].tex->Release();
				SPwindow.tex->Release();	SPfire[1].tex->Release();
				// --------------------------------------------------
				FMUSIC_StopSong (bgmusic);
				
				return(1);
			}			
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else {
			dx8.pd3dDevice->BeginScene();
			dx8.pd3dxSprite->Begin();
			//--------------------------------------------------------

			//for (i=0;i<14;i++) 
			SPbg.Draw(0,0,0,0,100,0,0xFF0000FF);
			SPframe.Draw(16+x1,32,0,0,100,0,0);
			SPframe.Draw(160+x3,32,0,0,100,0,0);
			SPframe.Draw(160+x4,64,0,0,100,0,0);
			for (i=1;i<3;i++) SPframe.Draw(16+x2,32+32*i,0,0,100,0,0);
			for (i=0;i<4;i++) SPframe.Draw(16+x5,32+32*i,0,0,100,0,0);
			if (menu_ani == 0) {
				if (menu_mode == 0) {
					SPfire[0].Draw(16,32+32*menu_select,fire_phase,0,100,0,0);
					SPfire[0].Draw(144,32+32*menu_select,fire_phase,1,100,0,0);
				}
				if (menu_mode == 1) {
					SPfire[1].Draw(16,32,fire_phase,0,100,0,0);
					SPfire[1].Draw(144,32,fire_phase,1,100,0,0);

					SPfire[0].Draw(160,32+32*menu_select,fire_phase,0,100,0,0);
					SPfire[0].Draw(288,32+32*menu_select,fire_phase,1,100,0,0);
				}
				if (menu_mode > 1) {
					SPfire[1].Draw(160,32,fire_phase,0,100,0,0);
					SPfire[1].Draw(288,32,fire_phase,1,100,0,0);
					
					SPfire[1].Draw(160,64,fire_phase,0,100,0,0);
					SPfire[1].Draw(288,64,fire_phase,1,100,0,0);

					SPfire[0].Draw(16,32+32*menu_select,fire_phase,0,100,0,0);
					SPfire[0].Draw(144,32+32*menu_select,fire_phase,1,100,0,0);
				}

			}

			if ((menu_select == 0 && menu_mode == 0) || (menu_mode > 0))
				selc = 109; else selc = 0;
			SPfont.Draw(48+x1,40,6+selc,0,100,0,0); SPfont.Draw(56+x1,40,0+selc,0,100,0,0); SPfont.Draw(64+x1,40,12+selc,0,100,0,0);
			SPfont.Draw(72+x1,40,4+selc,0,100,0,0); SPfont.Draw(88+x1,40,18+selc,0,100,0,0); SPfont.Draw(96+x1,40,19+selc,0,100,0,0);
			SPfont.Draw(104+x1,40,0+selc,0,100,0,0); SPfont.Draw(112+x1,40,17+selc,0,100,0,0); SPfont.Draw(120+x1,40,19+selc,0,100,0,0);

			if (menu_select == 1 && menu_mode == 0)
				selc = 109; else selc = 0;
			SPfont.Draw(52+x2,72,2+selc,0,100,0,0); SPfont.Draw(60+x2,72,14+selc,0,100,0,0); SPfont.Draw(68+x2,72,13+selc,0,100,0,0);
			SPfont.Draw(76+x2,72,5+selc,0,100,0,0); SPfont.Draw(84+x2,72,8+selc,0,100,0,0); SPfont.Draw(92+x2,72,6+selc,0,100,0,0);
			SPfont.Draw(100+x2,72,20+selc,0,100,0,0); SPfont.Draw(108+x2,72,17+selc,0,100,0,0); SPfont.Draw(116+x2,72,4+selc,0,100,0,0);

			if (menu_select == 2 && menu_mode == 0)
				selc = 109; else selc = 0;
			SPfont.Draw(60+x2,104,14+selc,0,100,0,0); SPfont.Draw(68+x2,104,15+selc,0,100,0,0); SPfont.Draw(76+x2,104,19+selc,0,100,0,0);
			SPfont.Draw(84+x2,104,8+selc,0,100,0,0); SPfont.Draw(92+x2,104,14+selc,0,100,0,0); SPfont.Draw(100+x2,104,13+selc,0,100,0,0);
			SPfont.Draw(108+x2,104,18+selc,0,100,0,0);

			if (menu_select == 0 && menu_mode == 1)
				selc = 109; else selc = 0;
			SPfont.Draw(200+x3,40,13+selc,0,100,0,0); SPfont.Draw(208+x3,40,4+selc,0,100,0,0); SPfont.Draw(216+x3,40,22+selc,0,100,0,0);
			SPfont.Draw(232+x3,40,6+selc,0,100,0,0); SPfont.Draw(240+x3,40,0+selc,0,100,0,0); SPfont.Draw(248+x3,40,12+selc,0,100,0,0);
			SPfont.Draw(256+x3,40,4+selc,0,100,0,0);

			if ((menu_select == 1 && menu_mode == 1) || menu_mode > 1 )
				selc = 109; else selc = 0;
			SPfont.Draw(186+x4,72,18+selc,0,100,0,0); SPfont.Draw(194+x4,72,4+selc,0,100,0,0); SPfont.Draw(202+x4,72,11+selc,0,100,0,0);
			SPfont.Draw(210+x4,72,4+selc,0,100,0,0); SPfont.Draw(218+x4,72,2+selc,0,100,0,0); SPfont.Draw(226+x4,72,19+selc,0,100,0,0);
			SPfont.Draw(242+x4,72,5+selc,0,100,0,0); SPfont.Draw(250+x4,72,8+selc,0,100,0,0); SPfont.Draw(258+x4,72,11+selc,0,100,0,0);
			SPfont.Draw(266+x4,72,4+selc,0,100,0,0);

			if (menu_select == 0 && menu_mode > 1)
				selc = 109; else selc = 0;
			SPfont.Draw(72+x5,40,15+selc,0,100,0,0); SPfont.Draw(80+x5,40,11+selc,0,100,0,0); SPfont.Draw(88+x5,40,0+selc,0,100,0,0);
			SPfont.Draw(96+x5,40,24+selc,0,100,0,0);

			fire_cycles++;
			if (fire_cycles == 4) {
				fire_cycles = 0;
				fire_phase++;
				if (fire_phase == 4) fire_phase = 0;
			}
			
			if (menu_ani == 1) {
				x2-=8; x3-=8; x4-=8;
				if (x3 == 0) {
					menu_ani = 0;
					menu_mode = 1;
				}
			}
			if (menu_ani == 2) {
				x2+=8; x3+=8; x4+=8;
				if (x3 == 200) {
					menu_ani = 0;
					menu_mode = 0;
					menu_select = 0;
				}
			}
			if (menu_ani == 3) {
				x1+=8; x3+=8; x5+=8;
				if (x1 > 144) x1 = 144;
				if (x3 == 200) {
					menu_ani = 0;
					menu_mode = 2;
					menu_select = 0;
				}
			}
			if (menu_ani == 4) {
				x1-=8; x3-=8; x5-=8;
				if (x1 < 0) x1 = 0;
				if (x3 == 0) {
					menu_ani = 0;
					menu_mode = 1;
					menu_select = 1;
				}
			}

			if (menu_mode > 1) {
			for (i=0;i<23;i++)
				for (i2=0;i2<17;i2++)
					SPblack.Draw(155+26+i*4,26+74+i2*4,0,0,13,0,0xAA000000);
			SPwindow.Draw(155+21,26+72,4,0,100,0,0);
			SPwindow.Draw(155+115,26+72,6,0,100,0,0);
			SPwindow.Draw(155+21,26+138,9,0,100,0,0);
			SPwindow.Draw(155+115,26+138,11,0,100,0,0);
			for (i=0;i<11;i++) {
				SPwindow.Draw(155+29+i*8,26+72,5,0,100,0,0);
				SPwindow.Draw(155+29+i*8,26+138,10,0,100,0,0);
			}
			for (i=0;i<16;i++) {
				SPwindow.Draw(155+21,26+76+i*4,7,0,100,0,0);
				SPwindow.Draw(155+115,26+76+i*4,8,0,100,0,0);
			}
			
			col = 0xFF1212DD;
			//if (menu_select == 2) col -= ((menu_fade-80)/2)*0x01000000;
			if (menu_mode == 3)
				for (i=0;i<10;i++)
					SPblack.Draw(155+28+8*i,26+75+(menu_name)*8,0,0,25,0,col);

			if (sv_names < 9) {
				for (i=0;i<sv_names;i++)
					for (i2=0;i2<sv_lname[i];i2++)
						SPfont.Draw(155+28+i2*8,26+75+i*8,sv_name[i][i2],0,100,0,0);
			}
			else {
				for (i=0;i<8;i++)
					for (i2=0;i2<sv_lname[i+menu_pos];i2++)
						SPfont.Draw(155+28+i2*8,26+75+i*8,sv_name[i+menu_pos][i2],0,100,0,0);
			}
			}

			//--------------------------------------------------------
			dx8.pd3dxSprite->End();
			dx8.pd3dDevice->EndScene();

			if (menu_kd > 0) menu_kd--;
			if (menu_kd == 0 && menu_ani == 0) {
				if (kd_down) {
					menu_kd = 10;
					if (menu_mode < 3) {
						menu_select++;
						if (menu_mode == 0 && menu_select > 2) menu_select = 2;
						if (menu_mode == 1 && menu_select > 1) menu_select = 1;
						if (menu_mode == 2 && menu_select > 3) menu_select = 3;
					}
					else if (menu_name < sv_names-1-menu_pos) menu_name++;
					if (menu_name > 7) {
						menu_name = 7;
						menu_pos++;
					}
				}
				if (kd_up) {
					menu_kd = 10;
					if (menu_mode < 3) {
						if (menu_select > 0) menu_select --;
					}
					else if (menu_name > 0 || menu_pos > 0) menu_name--;
					if (menu_name < 0) {
						menu_name = 0;
						menu_pos--;
					}
				}
				if (kd_b) {
					menu_kd = 15;
					if (menu_mode == 3 && menu_select == 0) {
						// game start!!

						startlevel = sv_area[menu_name+menu_pos];

						// ----------------- release images -----------------
						SPbg.tex->Release();		
						SPframe.tex->Release();		SPfire[0].tex->Release();
						SPwindow.tex->Release();	SPfire[1].tex->Release();
						// --------------------------------------------------
						FMUSIC_StopSong (bgmusic);

						return(0);
					}
					if (menu_mode == 0 && menu_select == 0) menu_ani = 1;
					if (menu_mode == 1 && menu_select == 1) menu_ani = 3;
					if (menu_mode == 2) menu_mode = 3;
				}
				if (kd_a) {
					menu_kd = 15;
					if (menu_mode == 1) menu_ani = 2;
					if (menu_mode == 2) menu_ani = 4;
					if (menu_mode == 3) menu_mode = 2;
				}
			}			

			while (ctime < nextframe) {
				QueryPerformanceCounter((LARGE_INTEGER*)&ctime);
			}
			nextframe = ctime + tdist;

			dx8.pd3dDevice->Present( NULL, NULL, NULL, NULL );
		}
	}	
}

int game_over(void)
{
	Sprite SPgomoon, SPgocastle, SPgolet;
	int gocycles, gophase, godif;
	//D3DCOLOR col, mcol;


	SPgomoon.Create("sprites\\gameovermoon.png", 0xFFFF00FF, 320, 240, 512);
	SPgocastle.Create("sprites\\gameovercastle.png", 0xFF0000FF, 244, 215);
	SPgolet.Create("sprites\\gameoverlet.png", 0xFF000000, 288, 32);

	gocycles = 0;
	gophase = 0;
	godif = 1;

	i = 0;

	while (TRUE) { 
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
			if (msg.message == WM_QUIT) {
				CleanUp();
				return(1);
			}			
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else {
			dx8.pd3dDevice->BeginScene();
			dx8.pd3dxSprite->Begin();
			//--------------------------------------------------------

			SPgomoon.Draw(0,0,0,0,100,0,0);
			SPgocastle.Draw(50,146-i/4,0,0,100,0,0);
			SPgolet.Draw(12,-370+i,gophase,0,100,0,0xAAFFFFFF);
			
			i++;
			gocycles++;
			if (gocycles == 16) {
				gocycles = 0;
				gophase += godif;
				if (gophase == 0 || gophase == 2) godif *= -1;
			}
			
		/*	For i2=0 To 319
				DrawBlock melt(i2),i2,melty(i2)/10
				melty(i2) = melty(i2) + Rnd (1,16)
			Next */

			//--------------------------------------------------------
			dx8.pd3dxSprite->End();
			dx8.pd3dDevice->EndScene();

			while (ctime < nextframe) {
				QueryPerformanceCounter((LARGE_INTEGER*)&ctime);
			}
			nextframe = ctime + tdist;

			dx8.pd3dDevice->Present( NULL, NULL, NULL, NULL );

			if (i == 480) {
				SPgomoon.tex->Release();
				SPgocastle.tex->Release();
				SPgolet.tex->Release();

				return(1);	// game over menu
			}
		}
	}	
}