void Handle_Subweapons(void)
{
	int n_del, sdif;
	
	n_del = 0;
	if (freeze == 0 || freeze == 2) {
		for (i=0;i<n_sub;i++) {
			if (sub_type[i] == 2) {
				sub_cycles[i]++;
				sub_x[i] += 100*(1-2*sub_dir[i]);
				sub_rect[i][0] = sub_x[i]; sub_rect[i][1] = sub_y[i]-10;
				sub_rect[i][2] = 320; sub_rect[i][3] = 40;
				sub_y[i] += sub_extra[i];
			}

			if (sub_type[i] == 3) {
				sub_phase[i]++;
				if (sub_phase[i] > 23) sub_phase[i] = 0;
				sub_extra[i]++;
				sub_x[i] += 25*(1-2*sub_dir[i]);
				sub_y[i] += (int)(sub_extra[i]*2.4f) - 56;
				sub_rect[i][0] = sub_x[i]-160; sub_rect[i][1] = sub_y[i]-160;
				sub_rect[i][2] = 320; sub_rect[i][3] = 320;
			}
			
			if (sub_type[i] == 4) {
				if (sub_phase[i] == 0 || sub_phase[i] == 26) {
					sub_extra[i]++;
					sub_x[i] += 25*(1-2*sub_dir[i]);
					sub_y[i] += sub_extra[i]*2;
		
					sub_rect[i][0] = sub_x[i]+40; sub_rect[i][1] = sub_y[i]+360;
					sub_rect[i][2] = 110; sub_rect[i][3] = 120;
					
					if (onblock(sub_rect[i][0],sub_rect[i][0]+80,sub_rect[i][1]+100,2) == 1) {
						sub_extra[i] = 0;
						sub_phase[i]++;
						sub_cycles[i] = 8;
						FSOUND_PlaySound (FSOUND_FREE, FX_break);
					}
				}
				else {
					sub_rect[i][0] = sub_x[i]+30; sub_rect[i][1] = sub_y[i]+110;
					sub_rect[i][2] = 300; sub_rect[i][3] = 300;
					
					sub_cycles[i]--;
					if (sub_cycles[i] == 0) {
						sub_cycles[i] = 2;
						sub_phase[i]++;
						if (sub_phase[i] == 28) sub_phase[i] = 2;
						if (sub_phase[i] == 21) {
							if (sub_extra[i] == 0) sub_phase[i] = 12;
							if (sub_extra[i] == 1) sub_phase[i] = 7;
							sub_extra[i]++;
						}
						if (sub_phase[i] == 12 && sub_extra[i] == 2) sub_phase[i] = 21;
						if (sub_phase[i] == 26) {
							del[n_del] = i;
							n_del++;
						}
					}					
				}			
			}
			
			if (sub_type[i] == 5) {
				if (sub_extra[i] == 0 || sub_extra[i] > 7) sdif = 1; else sdif = 2;
				if ((sub_dir[i] == 0 || sub_extra[i] < 8) || (sub_dir[i] == 1 && sub_extra[i] > 7))
					sub_phase[i] += sdif;
				else
					sub_phase[i] -= sdif;				
				if (sub_phase[i] > 11) sub_phase[i] = 0;
				if (sub_phase[i] < 0) sub_phase[i] = 11;
				if (sub_phase[i] == 0 || sub_phase[i] == 11) {
					sub_cycles[i]++;
					if (sub_cycles[i] == 2) {
						FSOUND_PlaySound (FSOUND_FREE, FX_brang);
						sub_cycles[i] = 0;
						i2 = 0;

						if (debris_number == 200) debris_number--;
						db[debris_number].dtype = 4;				//sparklies
						db[debris_number].x = sub_x[i]-50;
						db[debris_number].y = sub_y[i];
						db[debris_number].phase = 0;
						db[debris_number].cycles = 0;
						db[debris_number].dur = 8;
						db[debris_number].type2 = myRand(0,1);
						debris_number++;
					}
					if (sub_extra[i] == 0) {
						if ((sub_x[i] > 2900 && sub_dir[i] == 0) || (sub_x[i] < 300 && sub_dir[i] == 1))
							sub_extra[i] = 1;
					}
					if (sub_extra[i] > 0 && sub_extra[i] < 9) sub_extra[i]++;
					if (sub_extra[i] == 8) {
						sub_dir[i] = 1-sub_dir[i];
						shadow_cycles[n_sub] = 0;
					}
				}
					
				if ((sub_dir[i] == 0 && sub_extra[i] == 0) || (sub_extra[i] > 7 && sub_dir[i] == 1)) {
					if (sub_x[i] > 2800) sub_x[i] -= 10*(1-2*sub_dir[i]);
				}
				if ((sub_dir[i] == 1 && sub_extra[i] == 0) || (sub_extra[i] > 7 && sub_dir[i] == 0)) {
					if (sub_x[i] < 400) sub_x[i] -= 10*(1-2*sub_dir[i]);
				}
				if (sub_extra[i] == 0 || sub_extra[i] > 7) sub_x[i] += 30*(1-2*sub_dir[i]);				
				
				sub_rect[i][0] = sub_x[i]-100; sub_rect[i][1] = sub_y[i]-100;
				sub_rect[i][2] = 200; sub_rect[i][3] = 200;
				if (hero_action == 2) {
					if (RectsOverlap(hero_rect[0]-80,hero_rect[1],hero_rect[2],hero_rect[3],sub_rect[i][0],sub_rect[i][1],1,8)) {
						del[n_del] = i;
						n_del++;
					}
				}
				else {
					if (RectsOverlap(hero_rect[0]-80,hero_rect[1],hero_rect[2],hero_rect[3],sub_rect[i][0],sub_rect[i][1],1,200)) {
						del[n_del] = i;
						n_del++;
					}
				}
			}
			
			if (sub_x[i] < -500 || sub_x[i] > 3700 || sub_y[i] > 2600) {
				del[n_del] = i;
				n_del++;
			}
					
		}
	}

	i = n_del-1;
	while (i > -1) {
		for (i2=del[i];i2<n_sub-1;i2++) {
			if (sub_type[i2] == 5) shadow_cycles[i2] = shadow_cycles[i2+1];
			sub_x[i2] = sub_x[i2+1];
			sub_y[i2] = sub_y[i2+1];		
			sub_cycles[i2] = sub_cycles[i2+1];
			sub_phase[i2] = sub_phase[i2+1];
			sub_type[i2] = sub_type[i2+1];
			sub_dir[i2] = sub_dir[i2+1];
			for (i3=0;i3<4;i3++) sub_rect[i2][i3] = sub_rect[i2+1][i3];
			sub_extra[i2] = sub_extra[i2+1];
			sub_kills[i2] = sub_kills[i2+1];
		}
		n_sub--;
		i--;
	}

	if (clk_timer > 0) {
		if (freeze == 0 && clk_timer > 0) freeze = 2;
		if (freeze == 2) {
			clk_timer--;
			if (clk_timer > 281) {
				for (i=0;i<6;i++) {
					clk_deg[i] -= 10;
					clk_x[i] = (int)(13+sin(float(clk_deg[i])*0.017453f)*(305-clk_timer)*2);
					clk_y[i] = (int)(17+cos(float(clk_deg[i])*0.017453f)*(305-clk_timer)*2);
				}
			}
			for (i=0;i<6;i++) {
				clk_cycles[i]--;
				if (clk_cycles[i] == 0) {
					clk_phase[i]++;
					clk_cycles[i] = 2;
					if (clk_phase[i] == 8) {
						FSOUND_PlaySound (FSOUND_FREE, FX_clock);
						i3 = myRand(1,3);
						for (i2=0;i2<i3;i2++) {
							if (debris_number == 200) debris_number--;
							db[debris_number].dtype = 1;										// c_burn
							db[debris_number].x = clk_x[i]*10+hero_x-myRand(10,70);
							db[debris_number].y = clk_y[i]*10+hero_y-myRand(80,130);
							db[debris_number].cycles = 4;
							db[debris_number].phase = 0;
							debris_number++;
						}
					}
				}
			}
		}
		if (clk_timer == 0) freeze = 0;
	}

	if (clk_timer == 0 && freeze == 0 && music_play == 0) {
		// and not paused resume music
		FMUSIC_SetPaused (bgmusic, false);
		music_play = 1;
	}
	
}

void Handle_Debris(void)
{
	int n_del;

	n_del = 0;
	for (i=0;i<debris_number;i++) {
		if (db[i].dtype == 0) {						// spark
			db[i].cycles--;
			if (db[i].cycles == 6 && db[i].phase == 1) db[i].phase = 2;
			if (db[i].cycles == 0) {
				del[n_del] = i;
				n_del++;
			}
		}
		if (db[i].dtype == 1) {						// c_burn
			db[i].cycles--;
			if (db[i].cycles == 0) {
				db[i].cycles = 4;
				db[i].phase++;
				if (db[i].phase == 7) {
					del[n_del] = i;
					n_del++;
				}
			}
		}
		if (db[i].dtype == 3) {						// bone
			db[i].phase += (1-2*db[i].dir) * db[i].turn;
			if (db[i].phase < 0) db[i].phase = 359;
			if (db[i].phase > 359) db[i].phase = 0;

			/*if (db[i].type2 == 1) {
				//if (myRand(0,5) == 1) {
					if (debris_number == 200) debris_number--;
					db[debris_number].dtype = 7;										// c_burn
					db[debris_number].x = db[i].x-190+myRand(0,160);
					db[debris_number].y = db[i].y-190+myRand(0,160);
					db[debris_number].dur = 12;
					debris_number++;
				//}
			}*/
			
			db[i].x += db[i].xdif/10*(1-2*db[i].dir);
			db[i].y -= db[i].speed/10;
			db[i].speed -= 15;
			
			if (db[i].type2 == 0) {
				if (onblock(db[i].x-7,db[i].x+7,db[i].y+15,1) == 1) {
					db[i].y += db[i].speed/10;
					db[i].speed = (-(db[i].speed)*2)/3;
					db[i].turn -= 6;
					if (db[i].turn < 3) db[i].turn = 3;
				}
			}			
			
			db[i].dur--;
			if (db[i].dur == 0) {
				del[n_del] = i;
				n_del++;
			}
		}
		if (db[i].dtype == 4) {						// sparklies
			db[i].cycles++;
			if (db[i].cycles == 4) {
				db[i].phase++;
				if (db[i].phase == 2) db[i].phase = 0;
				db[i].dur--;
				db[i].cycles = 0;
			}
			if (db[i].dur == 0) {
				del[n_del] = i;
				n_del++;
			}
			db[i].y += 8;
		}
		if (db[i].dtype == 5) {						// score
			db[i].cycles++;
			if (db[i].cycles == 120) {
				del[n_del] = i;
				n_del++;
			}
		}
		if (db[i].dtype == 6) {						// enemy death component
			db[i].cycles++;
			if (db[i].cycles == 2) {
				db[i].cycles = 0;
				db[i].dur--;
				if (db[i].dur == 0) {
					del[n_del] = i;
					n_del++;
				}
			}
			if (db[i].dur < 8) db[i].y -= 4;
			if (db[i].dur < 6) db[i].phase++;
		}
		if (db[i].dtype == 7) {						// skull trail
			db[i].dur--;
			if (db[i].dur == 0) {
				del[n_del] = i;
				n_del++;
			}
		}
		if (db[i].dtype == 8) {						// dust
			db[i].cycles--;
			db[i].dur--;
			db[i].x += (1-2*db[i].dir)*3;
			db[i].y -= 2;
			//db[i].speed--;
			if (db[i].cycles == 0) {
				db[i].phase++;
				db[i].cycles = 8;				
				if (db[i].phase == 6) {
					del[n_del] = i;
					n_del++;
				}
			}
		}
		if (db[i].dtype == 9) {						// batdeath
			db[i].cycles++;
			if (db[i].cycles == 10) db[i].cycles = 0;


		}

	}

	i = n_del-1;
	while (i > -1) {
		for (i2=del[i];i2<debris_number-1;i2++) {
			db[i2].dtype = db[i2+1].dtype;
			db[i2].x = db[i2+1].x;
			db[i2].y = db[i2+1].y;
			db[i2].cycles = db[i2+1].cycles;
			db[i2].phase = db[i2+1].phase;
			db[i2].dur = db[i2+1].dur;
			db[i2].type2 = db[i2+1].type2;
			db[i2].turn = db[i2+1].turn;
			db[i2].dir = db[i2+1].dir;
			db[i2].speed = db[i2+1].speed;
			db[i2].xdif = db[i2+1].xdif;
		}
		debris_number--;
		i--;
	}
}

void inc_score(int v1, int v2, int v3, int v4, int v5)
{
	int oldscore, sii;

	oldscore = score_f;
	score[0] += v5;
	score[1] += v4;
	score[2] += v3;
	score[3] += v2;
	score[4] += v1;
	for (sii=0;sii<8;sii++) { 
		while (score[sii] > 9) {
			score[sii+1] += 1;
			score[sii] -= 10;
		}
	}
	score_f = score_f + v5+v4*10+v3*100+v2*1000+v1*10000;
	if (oldscore < 20000 && score_f > 19999) players[0]++;		// sound
	if (oldscore < 50000*newlife && score_f > 50000*newlife-1) {
		players[0]++;
		newlife++;
	}
	if (players[0] > 9) { players[0] -= 10; players[1]++; }
}

bool RectsOverlap(int x1, int y1, int w1, int h1, int x2, int y2, int w2, int h2)
{
	if ((x1+w1 > x2 && x2+w2 > x1) || (x2+w2 > x1 && x1+w1 > x2))
		if ((y1+h1 > y2 && y2+h2 > y1) || (y2+h2 > y1 && y1+h1 > y2)) return(true);
	return(false);
}

int myRand(int low, int high)
{
	// just a wrapper for the rand() funtion that allows you to specify
	// high and low boundaries.
	return(rand()*(high-low+1)/(RAND_MAX+1)+low);
}
