void Render(void)
{
	int val, sphase1, sphase2, sdif, r_dx, r_dy;
	D3DCOLOR dci;

	// Clear the backbuffer to a black color
	dx8.pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET, 
		D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );

	// Begin the scene
	dx8.pd3dDevice->BeginScene();

	dx8.pd3dxSprite->Begin();

	//dx8.pd3dDevice->SetRenderTarget(0, subBuffer);
	if (y_offset != 0) yscroll((y_offset/10)*10);
	
	// draw bg's
	for (i=0;i<n_bg;i++) {
		if (bgsx[i] == 0) {
			backg[i].Draw(bgx[i],bgy[i],0,0,100,0,0);
		}
		else {
			dx = bgx[i]-screen_px/bgsx[i];
			do {
					if (bgsy[i] == 0)
						backg[i].Draw(dx,bgy[i],0,0,100,0,0);
					else
						backg[i].Draw(dx,bgy[i]-screen_py/bgsy[i],0,0,100,0,0);
				dx += backgn[i];
			} while (dx < 320);
		}

	/*	if (i == 1) {
			// !!!!!!!!!!!!!
			i2 = cloudpos[0]/10;
			while (i2 < 319) {
				SPclouds[0].Draw(i2,0,0,0,100,0,0x99FFFFFF);
				i2 += 256;
			}
			i2 = cloudpos[1]/10;
			while (i2 < 319) {
				SPclouds[2].Draw(i2,18,0,0,100,0,0x88FFFFFF);
				i2 += 256;
			}
			i2 = cloudpos[2]/10;
			while (i2 < 319) {
				SPclouds[1].Draw(i2,48,0,0,100,0,0x77FFFFFF);
				i2 += 256;
			}
			cloudpos[0] -= 8;
			cloudpos[1] -= 4;
			cloudpos[2] -= 2;
			for (i2=0;i2<3;i2++)
				if (cloudpos[i2] < -2559) cloudpos[i2] += 2560;
		}*/
	}

	if (flag[0] > 0) {
		if (fogx2 > 0) fogx2 -= 2560;
		if (fogy2 > 0) fogy2 -= 2240;
		i=fogx2/10;
		while (i < 320) {
			i2=fogy2/10;
			while (i2 < 240) {
				SPfog2.Draw(i,i2,0,0,100,0,0x80FFFFFF);
				i2+=224;
			}
			i+=256;
		}
		fogx2 += 3;		
	}

	/*rain_cycles++;
	if (rain_cycles == 4) {
		rain_cycles = 0;
		rain_phase++;
		if (rain_phase == 4) rain_phase = 0;
	}

	for (i=0;i<5;i++)
		for (i2=0;i2<4;i2++) SPrain.Draw(i*64,i2*64,
			rain_phase,0,100,0,0x77FFFFFF);*/

	anicycles--;
	if (anicycles < 1) {
		anicycles = ani_speed;
		aniphase++;
		if (aniphase == 4) aniphase = 0;
	}			

	// draw tile bg's and anitiles
	for (i3=0;i3<2;i3++) {
		for (i=screen_px/24/tbsx[i3];i<screen_px/24/tbsx[i3]+15;i++) {
			for (i2=screen_py/24/tbsy[i3];i2<screen_py/24/tbsy[i3]+11;i2++) {
				if (i3 == 0) val = bgA[i][i2]; else val = bgB[i][i2];
				if (val > -1 && i < bnbx[i3] && i2 < bnby[i3]) {
					tiles[val].Draw(i*24-screen_px/tbsx[i3],
						i2*24-screen_py/tbsy[i3],0,0,100,0,0);	
				}
			}
		}
		for (i=0;i<n_ani;i++) {
			if (ani_x[i] > 99+i3*100 && ani_x[i] < 200+i3*100) { //on - screen ONLY!!!
				anis[ani_t[i]].Draw((ani_x[i]-100-i3*100)*24-screen_px/tbsx[i3],
					ani_y[i]*24-screen_py/tbsy[i3],aniphase,0,100,0,0);
			}
		}
	}

	// draw the walking ground (and anitiles)
	for (i=screen_px/240-1;i<screen_px/240+15;i++) {
		for (i2=screen_py/240-1;i2<screen_py/240+11;i2++) {
			if (i2 > -1 && i > -1) {
				if (t[level[i][i2]].pic > -1) {
					tiles[t[level[i][i2]].pic].Draw(i*24-screen_px/10,
						i2*24-screen_py/10,0,0,100,0,0);								
				}
				if (t[level[i][i2]].stair > -1) {
					if (t[level[i][i2]].stair > 99) {
						stairs[t[level[i][i2]].stair-100].Draw(i*24-screen_px/10,
							i2*24-screen_py/10,0,0,100,0,0);
					}
					else {
						stairs[t[level[i][i2]].stair].Draw(i*24-screen_px/10,
							i2*24-screen_py/10,0,1,100,0,0);
					}				
				}
			}
		}
	}

	for (i=0;i<n_ani;i++) {
		if (ani_x[i] < 100) { //on - screen ONLY!!!
			anis[ani_t[i]].Draw(ani_x[i]*24-screen_px/10,ani_y[i]*24-screen_py/10,
				aniphase,0,100,0,0);
		}
	}

	for (i=0;i<n_sblock;i++) {
		if ((sblock_t[i] == 1 || sblock_t[i] == 2) && sblock_phase[i] > 0 && sblock_phase[i] < 9)
			SPcrumble.Draw(sblock_x[i]*24-screen_px/10,sblock_y[i]*24-screen_py/10,sblock_phase[i]-1,0,100,0,0);

	}

	for (i=0;i<13;i++) {
		SPblack.Draw(0+24*i,-6-screen_py/10,0,0,100,0,0xFF000000);
		SPblack.Draw(0+24*i,-30-screen_py/10,0,0,100,0,0xFF000000);
	}

	// rotoblocks
	for (i=0;i<n_roto;i++) {
		if (roto_spikes[i] == 0)
			SPrblock.Draw((roto_x[i]-screen_px)/10,(roto_y[i]-screen_py)/10-18,0,0,100,3600-roto_phase[i]*75,0); // phase
		//else
		//	DrawImage sblock_r(roto_phase(i)+12*(roto_spikes(i)-1)),(roto_x(i)-screen_px)/10+24,(roto_y(i)-screen_py)/10+12
	}

	//SPLAT!!
	for (i=0;i<n_splat;i++)
		SPrblock.Draw((splat_x[i]-screen_px)/10,splat_p[i]/10-screen_py/10-18,0,0,100,0,0);

	// gears
	for (i=0;i<n_gears;i++) {
		if (gear_t[i] == 0) sdif = 108; else sdif = 60;
		if (gear_t[i] == 2) i2 = -60; else i2 = 0;
		SPgear[gear_t[i]].Draw((gear_x[i]-screen_px)/10-sdif,(gear_y[i]-screen_py)/10-sdif,0,0,100,-gear_apos[i]-i2,0);
	}

	// pendulumses
	for (i=0;i<n_pend;i++) {
		for (i2=0;i2<(pend_l[i]/21)+1;i2++) {
			r_dx = (int)(sin((float)pend_pos[i]/18000.0f*3.14159f)*21*i2);
			r_dy = (int)(cos((float)pend_pos[i]/18000.0f*3.14159f)*21*i2);		
			SPpendbar.Draw((pend_x[i]-screen_px)/10+r_dx+10,(pend_y[i]-screen_py)/10+r_dy,
			0,0,100,pend_pos[i]/10,0);
		}

		SPpend.Draw((pend_cx[i]-screen_px)/10-12,(pend_cy[i]-screen_py)/10-12,0,0,100,pend_pos[i]/10,0);
	}

	// crushers
	for (i=0;i<n_crush;i++) {
		for (i2=0;i2<crush_h[i]*2;i2++)
			SPcrusher[2].Draw(crush_x[i]*24-screen_px/10,
			crush_y[i]*24-screen_py/10-12*(i2-1),0,0,100,0,0);
		
		if (crush_t[i] == 1)
			SPcrusher[1].Draw(crush_x[i]*24-screen_px/10,
			crush_y[i]*24-screen_py/10-24*crush_h[i]+12,0,0,100,0,0);
		
		SPcrusher[0].Draw(crush_x[i]*24-screen_px/10,
			crush_y[i]*24-screen_py/10-24*crush_h[i]-12+crush_p[i]/10+36,0,0,100,0,0);
	}

	for (i=0;i<n_teeter;i++)
		SPteeter.Draw((teeter_x[i]-725-screen_px)/10,(teeter_y[i]-45-screen_py)/10,0,0,100,teeter_r[i],0);

	// doors...
	for (i=0;i<n_doors;i++) {
		if (i == exitdoor-1)
			SPdoor[door_type[i]].Draw(door_x[i]/10-screen_px/10,door_y[i]/10-screen_py/10,door_phase,0,100,0,0);
		else
			SPdoor[door_type[i]].Draw(door_x[i]/10-screen_px/10,door_y[i]/10-screen_py/10,0,0,100,0,0);
	}

	// draw items
	for (i=0;i<item_number;i++) {
		if (it[i].dur > 60 || blink_phase == 0 || it[i].dur == -1) {
			if (it[i].itype < 2)
				SPitems.Draw(it[i].x/10,it[i].y/10,2*it[i].itype+it[i].phase,0,100,0,0);			
			if (it[i].itype > 1 && it[i].itype < 10)
				SPitems.Draw(it[i].x/10,it[i].y/10,10+it[i].itype+it[i].phase*8,0,100,0,0);
			if (it[i].itype > 9 && it[i].itype < 22)
				SPitems.Draw(it[i].x/10,it[i].y/10,26+it[i].itype,0,100,0,0);			
			if (it[i].itype == 23) SPitems.Draw(it[i].x/10,it[i].y/10,50,0,100,0,0);
		}
	}
			
	// draw enemies
	for (i=0;i<enemy_number;i++) {
		if (e[i].etype == 1) {
			e[i].cycles--;
			if (e[i].cycles == 0) {
				e[i].phase++;
				if (e[i].phase > 3) e[i].phase = 0;
				e[i].cycles = 4;
			}
			
			i2 = myRand(0,8);
			if (i2 < 2)  //(e[i].phase == 0)
				SPcandlefire.Draw(e[i].x/10-8+myRand(0,2),e[i].y/10-2+myRand(0,1),
				0,0,100,0,0x5333A3F3-myRand(0,5)*0x06000000);
			if (i2 > 1 && i2 < 6) //(e[i].phase == 1 || e[i].phase == 3)
				SPcandlefire.Draw(e[i].x/10-8+myRand(0,2),e[i].y/10-1+myRand(0,1),
				0,0,93,0,0x586F93F3-myRand(0,5)*0x06000000);
			if (i2 > 5) //(e[i].phase == 2)
				SPcandlefire.Draw(e[i].x/10-8+myRand(0,2),e[i].y/10-2+myRand(0,1),
				0,0,100,0,0x53AA83F3-myRand(0,5)*0x06000000);

			if (e[i].phase == 0 || e[i].phase == 1) i2 = 0; else i2 = 1;
			SPcandle.Draw(e[i].x/10,e[i].y/10,i2,0,100,0,0);
		}
		if (e[i].etype == 2) {
			e[i].cycles--;
			if (e[i].cycles == 0) {
				e[i].phase++;
				e[i].cycles = 6;
				if (e[i].phase > 7) e[i].phase = 0;
			}
			SPtorch.Draw(e[i].x/10,e[i].y/10,e[i].phase,0,100,0,0);
		}
		if (e[i].etype == 3)
			tiles[e[i].special].Draw(e[i].x/10,e[i].y/10,0,0,100,0,0);

		if (e[i].etype == 11 || e[i].etype == 17)
			SPskeleton.Draw(e[i].x/10,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);
		if (e[i].etype == 12)
			SPbonepillar.Draw(e[i].x/10,e[i].y/10,e[i].phase,e[i].dir,100,0,0);
		if (e[i].etype == 13)
			SPbat.Draw(e[i].x/10,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);
		if (e[i].etype == 14)
			SPzombie.Draw(e[i].x/10,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);
		if (e[i].etype == 15)
			SPmedusahead.Draw(e[i].x/10,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);
		if (e[i].etype == 16)
			SPigor.Draw(e[i].x/10,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);
		if (e[i].etype == 18)
			SPspearman.Draw(e[i].x/10,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);

		if (e[i].etype == 23)
			SPdhuron.Draw((e[i].x-e[i].extra*580)/10,e[i].y/10,e[i].phase,e[i].extra,100,0,0);

		if (e[i].etype == 24)
			SPspecter.Draw(e[i].x/10,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0xFFFFFFFF-(e[i].extra/10)*0x01000000);


		if (e[i].etype == 100) {
			SPcandlefire.Draw(e[i].x/10-3,e[i].y/10-3,
				0,0,75,0,0x35CFBF00); //0x53AA83F3-myRand(0,5)*0x06000000);
			SPfireball.Draw(e[i].x/10,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);
		}
		if (e[i].etype == 101)
			SPbone.Draw(e[i].x/10-12,e[i].y/10-12,0,0,100,3600-150*e[i].phase,0);
		
		if (e[i].etype == 1001) {
			if (e[i].dir == 1)
				SPboss.Draw(e[i].x/10-56,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);
			else SPboss.Draw(e[i].x/10-9,e[i].y/10,e[i].phase,(1-e[i].dir),100,0,0);
	
		}

		//SPbars.Draw((e[i].rect1+e[i].x)/10,(e[i].rect2+e[i].y)/10,0,0,100,0,0);
		//SPbars.Draw((e[i].rect1+e[i].x+e[i].rect3)/10,(e[i].rect2+e[i].y+e[i].rect4)/10,0,0,100,0,0);

	}

	/*if (bossw_active == 1) {
		SPbars.Draw(bossw_x/10,bossw_y/10,0,0,100,0,0);
		SPbars.Draw(bossw_x/10+bossw_w/10,bossw_y/10+bossw_h/10,0,0,100,0,0);
	}*/

	drawbar();	// draw the... oh, you know.

	// debris class
	for (i=0;i<debris_number;i++) {
		if (db[i].dtype == 0)
			SPsparks.Draw(db[i].x/10,db[i].y/10,db[i].phase,0,100,0,0xFFFFFFFF);
		if (db[i].dtype == 1)
			SPsparks.Draw(db[i].x/10,db[i].y/10,3+db[i].phase,0,100,0,0xCCFFFFFF);

		if (db[i].dtype == 3) {
			if (db[i].dur < 30) i2 = db[i].dur; else i2 = 255;
			SPbone.Draw(db[i].x/10-12,db[i].y/10-12,db[i].type2,0,100,3600-10*db[i].phase,
				0xFFFFFFFF-(255-i2)*0x08000000);
		}
		if (db[i].dtype == 4) {
			if (db[i].dur < 7) i2 = ((6-db[i].dur)*4+db[i].cycles)*0x08000000;
				else i2 = 0;
			SPsparklies.Draw(db[i].x/10,db[i].y/10,db[i].phase=2*db[i].type2,0,100,
				0,0xCCFFFFFF-i2);
		}
		if (db[i].dtype == 5) {
			if (db[i].cycles > 59) dci = 0xFFFFFFFF - 0x04000000*(db[i].cycles-60);
				else dci = 0xFFFFFFFF;
			SPscoref.Draw(db[i].x/10,db[i].y/10-db[i].cycles/8,db[i].type2,0,100,0,dci);
			for (i2=1;i2<db[i].phase+1;i2++)
				SPscoref.Draw(db[i].x/10+6*i2,db[i].y/10-db[i].cycles/8,0,0,100,0,dci);
		}
		if (db[i].dtype == 6)
			if (db[i].dur < 8) {
				dci = 0xFFFFFFFF - db[i].phase*0x10000000;
				SPenemydeath.Draw(db[i].x/10,db[i].y/10,7-db[i].dur,0,100,0,dci);
			}
		if (db[i].dtype == 7) {
			if (db[i].dur < 8) {
				dci = 0x55FFFFFF; //0x00FFFFFF + db[i].dur * 0x22000000;
				SPenemydeath.Draw(db[i].x/10,db[i].y/10,5,0,100,0,dci);
			}
		}
		
		if (db[i].dtype == 8) {
			dci = 0x00FFFFFF + 0x01000000 * ((db[i].dur*255)/48);
			SPdust.Draw(db[i].x/10,db[i].y/10,db[i].phase,0,100,0,dci);

		}
		if (db[i].dtype == 9) {
			//if (db[i].cycles < 5)
				SPbat.Draw(db[i].x/10,db[i].y/10,4,db[i].dir,100,180,0);
			//else SPbat.Draw(db[i].x/10,db[i].y/10,3,db[i].dir,100,0,0);

			//SPenemydeath.Draw(db[i].x/10,db[i].y/10+10,
			//	db[i].cycles/5+4,0,100,0,0x88FFFFFF);
		}

	}

	// draw the hero's weapon, then himself.
	if (hero_inv < 2) {
	if (hero_whip == 2 && hero_wphase == 3) afact = 180; else afact = 255;

	oldx = -1;
	if (hero_x > 1400 && hero_x < 1420) {
		oldx = hero_x;
		hero_x = 1410;
	}
	if (hero_x > 1340 && hero_x < 1360) {
		oldx = hero_x;
		hero_x = 1350;
	}
	if (hero_dir == 0) {
		if ((hero_wcycles > 0) && hero_throw == 0 && (hero_frame < 40 || hero_frame > 58)) {
			if (hero_action == 2) {
				if (hero_wphase == 2) {
					i = hero_x-220;
					i2 = hero_y+60;
				}
				else {
					i = hero_x-230;
					i2 = hero_y+110;
				}
			}
			else {
				if (hero_action > 0 && hero_wphase == 0) {
					i = hero_x-200;
					i2 = hero_y-20;
				}
				else {
					i = hero_x-190;
					i2 = hero_y-50;
				}
			}
			// fix right jump & duck!
			if (hero_onobj > 0 && hero_ontype == 0) {
				i -= 20;
				i2 -= 20;
			}
			SPWhip[hero_whip].Draw(i/10,i2/10,hero_wphase,0,100,0,0);
		}
		i3 = 0;
	}
	else {
		if ((hero_wcycles > 0) && hero_throw == 0 && (hero_frame < 40 || hero_frame > 58)) {
			if (hero_action == 2) {
				if (hero_wphase == 2) {							
					i = hero_x-630;
					i2 = hero_y+60;
				}
				else {
					i = hero_x-620;
					i2 = hero_y+110;
				}
			}
			else {
				if (hero_action > 0 && hero_wphase == 0) {
					i = hero_x-640;
					i2 = hero_y-20;
				}
				else {
					i = hero_x-620;
					i2 = hero_y-50;
				}
			}
			SPWhip[hero_whip].Draw(i/10,i2/10,hero_wphase,1,100,0,0);
		}
		i3 = -50;
	}

	dci = 0xFFFFFFFF;
	if (hero_frame == 45) {
		dci = 0;

		if (hero_phase == 1)
			dci = 0xFFFF0000 + ((255*(100-hero_hdif))/100) * 0x00000101;
		if (hero_phase == 2)
			dci = 0x00FF0000 + ((255*(100-hero_hdif))/100) * 0x01000000;
	}

	if (dci > 0)
		SPHero.Draw((hero_x+i3)/10,hero_y/10,hero_frame,hero_dir,100,0,dci);

	if (oldx > -1) hero_x = oldx;
	}

	for (i=0;i<n_sub;i++) {			// subweapons
		if (sub_type[i] == 2)
			SPdagger.Draw(sub_x[i]/10,sub_y[i]/10,0,sub_dir[i],100,0,0);
			
		if (sub_type[i] == 3) {
			if (sub_dir[i] == 0)
				SPaxe.Draw(sub_x[i]/10-16,sub_y[i]/10-16,0,0,100,3600-sub_phase[i]*150,0);
			else SPaxe.Draw(sub_x[i]/10-16,sub_y[i]/10-16,0,1,100,sub_phase[i]*150,0);
		}

		if (sub_type[i] == 4) {
			if (sub_phase[i] < 2 || sub_phase[i] > 25)
				SPwater.Draw(sub_x[i]/10,sub_y[i]/10,sub_phase[i],sub_dir[i],100,0,0);
			else SPwater.Draw(sub_x[i]/10,sub_y[i]/10,sub_phase[i],sub_dir[i],100,0,0x99FFFFFF);
		}
			
		if (sub_type[i] == 5) {		
			if (sub_extra[i] == 0 || sub_extra[i] > 7)
				shadow_cycles[i] += 2;
			else shadow_cycles[i] -= 4;
			if (shadow_cycles[i] < 0) shadow_cycles[i] = 0;
			if (shadow_cycles[i] > 60) shadow_cycles[i] = 60;
			if (sub_dir[i] == 0) {
				sphase2 = sub_phase[i] - 2; if (sphase2 < 0) sphase2 += 12;
				sphase1 = sphase2 - 2; if (sphase1 < 0) sphase1 += 12;
			}
			else {
				sphase2 = sub_phase[i] + 2; if (sphase2 > 11) sphase2 -= 12;
				sphase1 = sphase2 + 2; if (sphase1 > 11) sphase1 -= 12;
			}
			if (sub_dir[i] == 0) sdif = -1; else sdif = 1;

			SPcross.Draw(sub_x[i]/10-10+shadow_cycles[i]/3*sdif,sub_y[i]/10-10,1,0,100,3600-sphase1*75,0x77FFFFFF);
			SPcross.Draw(sub_x[i]/10-10+shadow_cycles[i]/6*sdif,sub_y[i]/10-10,2,0,100,3600-sphase2*75,0x99FFFFFF);
			SPcross.Draw(sub_x[i]/10-10,sub_y[i]/10-10,0,0,100,3600-sub_phase[i]*75,0);
		}

		//!!!!!!!!!
		//SPbars.Draw(sub_rect[i][0]/10,sub_rect[i][1]/10,0,0,100,0,0);
		//SPbars.Draw((sub_rect[i][0]+sub_rect[i][2])/10,(sub_rect[i][1]+sub_rect[i][3])/10,0,0,100,0,0);
	}
	if (clk_timer > 0 && freeze == 2) {
		for (i=0;i<6;i++) {
			if (clk_timer > 281) i2 = clk_timer - 282;
				else i2 = 0;
			if (clk_phase[i] < 8)
				SPwatch.Draw(hero_x/10+clk_x[i],hero_y/10+clk_y[i],
					clk_phase[i],0,100-i2*3,0,0);
		}
	}
	
	if (flag[0] > 0) {
		if (fogx1 > 0) fogx1 -= 2560;
		if (fogy1 > 0) fogy1 -= 2240;
		i=fogx1/10;
		while (i < 320) {
			i2=fogy1/10;
			while (i2 < 240) {
				if (flag[0] == 1)
					SPfog1.Draw(i,i2,0,0,100,0,0x60FFFFFF);
				else SPfog1.Draw(i,i2,0,0,100,0,0x48FFFFFF);
				i2+=224;
			}
			i+=256;
		}
		if (flag[0] == 1) fogx1 += 5; else fogx1 += 2;
	}

	// cover the screen with translucent black, if fading
	if (f_action > 0) {
		if (f_phase == 0) f_phase = 1;
		for (i=0;i<10;i++) {
			for (i2=0;i2<8;i2++) {
				SPblack.Draw(i*32,i2*32,0,0,100,0,0x01000000*f_phase);
			}
		}				
		if (f_action == 1) {
			f_phase -= 8;
			if (f_phase < 0) f_action = 0;
		}
		if (f_action == 2) {
			f_phase += 12;
			if (f_phase > 255) f_action = 0;
		}				
	}

	if (intro_phase > 0) show_intro();

	if (y_offset != 0) yscroll(-(y_offset/10)*10);

	//CalcFrameRate(lpDDSBackBuffer);

	// End the scene
	dx8.pd3dxSprite->End();

	dx8.pd3dDevice->EndScene();

	while (ctime < nextframe) {
		QueryPerformanceCounter((LARGE_INTEGER*)&ctime);
	}
	nextframe = ctime + tdist;

	dx8.pd3dDevice->Present( NULL, NULL, NULL, NULL );
}

void drawbar(void)
{
	int i;

	for (i=0;i<10;i++) SPblack.Draw(32*i,0,0,0,100,0,0xA0000000);
	
	SPfont.Draw(16,4,18,0,100,0,0);
	SPfont.Draw(24,4,2,0,100,0,0);
	SPfont.Draw(32,4,14,0,100,0,0);
	SPfont.Draw(40,4,17,0,100,0,0);
	SPfont.Draw(48,4,4,0,100,0,0);
	SPfont.Draw(56,4,40,0,100,0,0);
	
	for (i=0;i<9;i++) 
		SPfont.Draw(64+i*8,4,30+score[8-i],0,100,0,0);

	SPfont.Draw(16,12,15,0,100,0,0);
	SPfont.Draw(24,12,11,0,100,0,0);
	SPfont.Draw(32,12,0,0,100,0,0);
	SPfont.Draw(40,12,24,0,100,0,0);
	SPfont.Draw(48,12,4,0,100,0,0);
	SPfont.Draw(56,12,17,0,100,0,0);
	SPfont.Draw(16,20,4,0,100,0,0);
	SPfont.Draw(24,20,13,0,100,0,0);
	SPfont.Draw(32,20,4,0,100,0,0);
	SPfont.Draw(40,20,12,0,100,0,0);
	SPfont.Draw(48,20,24,0,100,0,0);

	for (i=0;i<hero_hp-(hero_lhpdif*hero_losehp);i++) SPbars.Draw(72+4*i,12,0,0,100,0,0);
	for (i=hero_hp-(hero_lhpdif*hero_losehp);i<16;i++) SPbars.Draw(72+4*i,12,2,0,100,0,0);
	for (i=0;i<boss_hp;i++) SPbars.Draw(72+4*i,20,1,0,100,0,0);
	for (i=boss_hp;i<16;i++) SPbars.Draw(72+4*i,20,2,0,100,0,0);
	
	SPiwindow.Draw(144,4,0,0,100,0,0);

	SPfont.Draw(184,4,1,0,100,0,0);
	SPfont.Draw(192,4,11,0,100,0,0);
	SPfont.Draw(200,4,14,0,100,0,0);
	SPfont.Draw(208,4,2,0,100,0,0);
	SPfont.Draw(216,4,10,0,100,0,0);
	SPfont.Draw(232,4,30+block[0],0,100,0,0);
	SPfont.Draw(240,4,40,0,100,0,0);
	SPfont.Draw(248,4,30+block[1],0,100,0,0);
	if (block[2] < 10)
		SPfont.Draw(256,4,30+block[2],0,100,0,0);
	else SPfont.Draw(256,4,45+block[2],0,100,0,0);
	SPfont.Draw(184,12,42,0,100,0,0);
	SPfont.Draw(192,12,41,0,100,0,0);
	SPfont.Draw(200,12,30+hearts[1],0,100,0,0);
	SPfont.Draw(208,12,30+hearts[0],0,100,0,0);
	SPfont.Draw(224,12,15,0,100,0,0);
	SPfont.Draw(232,12,41,0,100,0,0);
	SPfont.Draw(240,12,30+players[1],0,100,0,0);
	SPfont.Draw(248,12,30+players[0],0,100,0,0);
	SPfont.Draw(184,20,19,0,100,0,0);
	SPfont.Draw(192,20,8,0,100,0,0);
	SPfont.Draw(200,20,12,0,100,0,0);
	SPfont.Draw(208,20,4,0,100,0,0);
	SPfont.Draw(224,20,30+time[2],0,100,0,0);
	SPfont.Draw(232,20,30+time[1],0,100,0,0);
	SPfont.Draw(240,20,30+time[0],0,100,0,0);

	//If spirit > 0 DrawImage portrait,280,7
	if (hero_double > 0) SPitems.Draw(252,8,41+hero_double,0,100,0,0);
	if (hero_weapon == 2) SPitems.Draw(149,-6,4,0,100,0,0);
	if (hero_weapon == 3) SPitems.Draw(148,0,5,0,100,0,0);
	if (hero_weapon == 4) SPitems.Draw(148,-1,6,0,100,0,0);
	if (hero_weapon == 5) SPitems.Draw(149,-3,7,0,100,0,0);
	if (hero_weapon == 6) SPitems.Draw(149,-1,8,0,100,0,0);
	if (hero_weapon > 6) SPitems.Draw(148,-1,2+hero_weapon,0,100,0,0);
}

/*void CalcFrameRate(LPDIRECTDRAWSURFACE7 lpDDSurface)
{
	DDSCAPS2 ddsCaps2; 

	DWORD total, free;
	int numout;

	thisTime	= timeGetTime();
	elapsedTime = thisTime - lastTime;
	lastTime	= thisTime;

	dwFrameCount++;

	dwTime = thisTime - dwFrameTime;
	if(dwTime > 1000) {
		dwFrames     = (dwFrameCount * 1000) /  dwTime;
		dwFrameTime  = thisTime;
		dwFrameCount = 0;
	}

	HDC hDC;

	lpDDSurface->GetDC(&hDC);

	char str[255];

	lpDD7->QueryInterface(IID_IDirectDraw7, (void **)&lpDD7);
	ZeroMemory(&ddsCaps2, sizeof(ddsCaps2));
	ddsCaps2.dwCaps = DDSCAPS_TEXTURE; 
	lpDD7->GetAvailableVidMem(&ddsCaps2, &total, &free); 

	SetBkMode(hDC,TRANSPARENT);
	SetTextColor(hDC,RGB(255,255,255));
	SetTextAlign(hDC,TA_LEFT);
	sprintf(str,"Frames: %d",dwFrames);
	TextOut(hDC,0,400,str,lstrlen(str));
	numout = (int)total;
	sprintf(str,"Total Texture Memory: %d",numout);
	TextOut(hDC,0,420,str,lstrlen(str));
	numout = (int)free;
	sprintf(str,"Free Texture Memory: %d",numout);
	TextOut(hDC,320,420,str,lstrlen(str));

	ZeroMemory(&ddsCaps2, sizeof(ddsCaps2));
	ddsCaps2.dwCaps = DDSCAPS_VIDEOMEMORY; 
	lpDD7->GetAvailableVidMem(&ddsCaps2, &total, &free);

	numout = (int)total;
	sprintf(str,"Total Video Memory: %d",numout);
	TextOut(hDC,0,440,str,lstrlen(str));
	numout = (int)free;
	sprintf(str,"Free Video Memory: %d",numout);
	TextOut(hDC,320,440,str,lstrlen(str));

	//TextOut(hDC,50,200,test1,lstrlen(test1));

	lpDDSurface->ReleaseDC(hDC);
}*/

HRESULT BltSpriteEx( RECT *pDestRect, LPDIRECT3DTEXTURE8 pSrcTexture, 
               RECT *pSrcRect, int dwFlags, D3DCOLOR modulate, 
               float rotation, POINT *prcenter)
{
	D3DXVECTOR2 scaling(1,1), rcenter(0,0), trans(0,0); 

     if (pDestRect) {
          trans.x = (float) pDestRect->left;
          trans.y = (float) pDestRect->top;
     } 

     if (prcenter) {
          rcenter.x = (float) prcenter->x;
          rcenter.y = (float) prcenter->y;
     } else if (pSrcRect) {
          rcenter.x = (float) (pSrcRect->right - pSrcRect->left) / 2;
          rcenter.y = (float) (pSrcRect->bottom - pSrcRect->top) / 2;
     }

     if (pDestRect && pSrcRect) {
          scaling.x = ((float) (pDestRect->right - pDestRect->left)) / 
               ((float) (pSrcRect->right - pSrcRect->left));
          scaling.y = ((float) (pDestRect->bottom - pDestRect->top)) / 
               ((float) (pSrcRect->bottom - pSrcRect->top));
     }

     if (pSrcRect && dwFlags > 0) {
          if (dwFlags == 1 || dwFlags == 3) { 
               scaling.x = -scaling.x; 
               trans.x += (float) (pDestRect->right - pDestRect->left);
			   rcenter.x -= (float) (pDestRect->right - pDestRect->left);
     }
          if (dwFlags == 2 || dwFlags == 3) { 
               scaling.y = -scaling.y; 
               trans.y += (float) (pDestRect->bottom - pDestRect->top);
			   rcenter.y -= (float) (pDestRect->bottom - pDestRect->top);
          }
     }
     	 
     return dx8.pd3dxSprite->Draw(pSrcTexture, pSrcRect, &scaling, 
               &rcenter, rotation, &trans, modulate);
}

void show_intro(void)
{
	if (intro_phase == 3) {
		SPintrorec.Draw(160-(56*(500-intro_cycles*10))/200
			,99-(48*(500-intro_cycles*10))/200
			,0,0,500-intro_cycles*10,0
			,0x01000000*((255*intro_cycles*2)/80)+0x00FFFFFF);
		if (intro_textdist > 400) intro_cycles--;
		if (intro_cycles == 20) intro_phase = 0;
		if (intro_textdist < 3000)
			intro_textdist = (intro_textdist*11)/10;
		i2 = 255-intro_textdist/5;
		if (i2 < 1) i2 = 1;
		SPintrotext.Draw(80-intro_textdist/10,96,0,0,100,0,
			0x01000000*i2+0x00FFFFFF);
	}
	if (intro_phase == 2) {
		SPintrorec.Draw(132,75,0,0,100,0,0);
		f_phase -= 2;		
		intro_textdist = (intro_textdist*10)/11;

		SPintrotext.Draw(78+intro_textdist/10,96,0,0,100,0,0);
		if (f_phase < 0 && f_action > 0) {
			f_action = 0;
			freeze = 0;
			intro_phase = 3;
			intro_textdist = 30;
			intro_cycles = 40;
		}
	}
	if (intro_phase == 1) {
		f_action = 3;
		f_phase = 255;
		SPintrorec.Draw(160-(56*(500-intro_cycles*10))/200
			,99-(48*(500-intro_cycles*10))/200
			,0,0,500-intro_cycles*10,0
			,0x01000000*((255*intro_cycles)/40)+0x00FFFFFF);
		intro_cycles++;
		if (intro_cycles == 41) {
			intro_phase = 2;
			intro_textdist = 3000;
		}
	}
}